/***********************************************************************/
/*                                                                     */
/*  FILE        :Photo_Frame.c                                         */
/*  DATE        :Tue, Sep 13, 2011                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/*                                                                     */
/***********************************************************************/

#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include "vect.h"
#include "iodefine.h"
#include "global_val.h"
#include "global_func.h"
#include "define_const.h"
#include "typedefine.h"
#include "../fatfs/diskio.h"
#include "../fatfs/ff.h"
#include "viewer.h"
#include "dcf.h"


/*---------------------------------------------------------*/
/* [NGA                                            */
/*---------------------------------------------------------*/

FATFS Fatfs;				/* t@CVXeIuWFNg */

struct dcf_info dcf_info;
struct dcf_file_info dcf_files[DCF_BUF_SIZE];

extern void add_jpeg_timer(), add_tick_timer(), add_disk_timer();

#define	RIGHTKEY_MASK	(1<<0)
#define	LEFTKEY_MASK	(1<<1)
#define	DOWNKEY_MASK	(1<<2)
#define	UPKEY_MASK	(1<<3)
#define	ASELKEY_MASK	(1<<4)
#define	BSELKEY_MASK	(1<<5)


void SD_Prompt()
{
	GCON_set_color(C_BLACK, C_GREEN);
	GCON_locate(3, 6);
	GCON_putstr("                                 ");
	GCON_locate(3, 7);
	GCON_putstr("      SDJ[h}āA       ");
	GCON_locate(3, 8);
	    GCON_putstr("   I{^ĂB  ");
	    GCON_putstr("    ʂɃ^b`ĂB   ");
	GCON_locate(3, 9);
	GCON_putstr("                                 ");
	GCON_set_color(C_WHITE, C_BLACK);
}


// main֐
void main(void)
{
    BYTE keydown;

    GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
    GRPH_Initialize();

    GCON_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
    GCON_Initialize();
    GCON_cursor_off();
    GCON_set_color(C_BLACK, C_WHITE);
    GCON_clear();

	ICU.IER[IER_CMT0_CMI0].BIT.IEN_CMT0_CMI0 = 0;	// Disable CMIE 
    add_jpeg_timer();
    add_tick_timer();
    add_disk_timer();
	ICU.IER[IER_CMT0_CMI0].BIT.IEN_CMT0_CMI0 = 1;	// Enable CMIE 

    keydown = (PORT4.PORT.BYTE >> 4) & 0x0f;
    keydown ^= (LEFTKEY_MASK | RIGHTKEY_MASK | UPKEY_MASK | DOWNKEY_MASK);

    if (keydown || df_check(&tp_calib_data) == 0) {
        GCON_locate(8, 7);
        t_printf("Lu[VJn܂");
        GCON_locate(11, 9);
        t_printf("ʂɃ^b`Ă");

        // ^b`܂ő҂
        while(global_touch == 0);

        while(global_touch==1);				//y܂ő҂

        // ^b`̃Lu[V
        cal_touch(&tp_calib_data);
    }
    GCON_locate(4, 8);
    t_printf("SDJ[hZbgă^b`Ă");

    while(global_touch==0);				//x^b`ďI
    while(global_touch==1);
	
    CMT.CMSTR0.BIT.STR1 = 1;	//start
    ev_init();

    while (1) {
        f_mount(0, &Fatfs);
		if (disk_status(0) & STA_NODISK) {
			GCON_locate(4, 8);
    		t_printf("SDJ[hZbgă^b`Ă");
			ev_wait(EV_PENUP);
			continue;
		}

    	GCON_set_color(C_WHITE, C_BLACK);
   		GCON_clear();

    	dcf_viewer();
    }
}
