/*
 *  JEITA DCF [`
 *	Ref. JEITA CP-3461A.
 */
#include <string.h>
#include "typedefine.h"
#include "viewer.h"
#include "dcf.h"

/*
 *  nthԖڈȍ~̃t@C
 */
int seek_DCF(int nth)
{
    int nfiles, fnumber;
    int index, num_read;
    FRESULT res;
    BYTE i;
    char *fn;
    char dirpath[16];
    DIR dirs, dcfdir;
    FILINFO dir_finfo, dcfdir_finfo;
    struct dcf_file_info *pdcf;
    FIL  jpegfile;

    if (nth >= dcf_info.num_files)
	return 0;
    if (nth == dcf_info.findex) {
	return dcf_info.nfiles;
    }
#ifdef DEBUG
    xprintf("seek: %d, %d\n", nth, dcf_info.findex);
#endif

    if (nth > dcf_info.findex && nth < dcf_info.findex + DCF_BUF_SIZE) {
	/* At least one file information is already there. */
	index = nth - dcf_info.findex;
	nfiles = dcf_info.nfiles - index;
	memcpy(&dcf_files[0], &dcf_files[index], sizeof(struct dcf_file_info)*nfiles);
	memset(&dcf_files[nfiles], 0, sizeof(struct dcf_file_info)*(DCF_BUF_SIZE-nfiles));
	dcf_info.findex = nth;
	dcf_info.nfiles = nfiles;
	/* Determin index to read */
	index = nfiles;
	nth = nth + nfiles;
	nfiles = DCF_BUF_SIZE - nfiles;
    } else {
	index = 0;
	nfiles = DCF_BUF_SIZE;
	dcf_info.findex = nth;
	dcf_info.nfiles = 0;
    }
    if (nth + nfiles > dcf_info.num_files)
        nfiles = dcf_info.num_files - nth;
#ifdef DEBUG
	xprintf("read: %d, %d, %d\n", nth, nfiles, index);
#endif
    /*
     *  nthԖڈȍ~Anfiles̃t@CɊւW߂āA
     *  obt@ indexŎʒuɊi[B
     */
    fnumber = num_read = 0;
    dcf_info.nfiles += nfiles;
    pdcf = dcf_files + index;

    strcpy(dirpath, "/DCIM/");
    res = f_opendir(&dirs, "/DCIM");	/* fBNgJ */
    if (res != FR_OK)
        return 0;

    while (((res = f_readdir(&dirs, &dir_finfo)) == FR_OK) && dir_finfo.fname[0]) {
	fn = dir_finfo.fname;	/* LFN\ł͏SFN */
	if (!(dir_finfo.fattrib & AM_DIR)) continue;	/* Skip non directory file */
        /*
         * DCFfBNg̍ŏ3 "000"`"999"łȂ΂ȂȂ
         */
        if (strncmp(fn, "100", 3) < 0 || strncmp(fn, "999", 3) > 0) continue;
        i = strlen(fn);
	if (i != 8) continue;
	strcpy(dirpath + 6, fn);
	dirpath[6 + i] = '\0';

	res = f_opendir(&dcfdir, dirpath);
        while (((res = f_readdir(&dcfdir, &dcfdir_finfo)) == FR_OK) && dcfdir_finfo.fname[0]) {
	    fn = dcfdir_finfo.fname;	/* LFN\ł͏SFN */
	    if (dcfdir_finfo.fattrib & AM_DIR) continue;
	    if (strlen(fn) != 12) continue;
	    if (strncmp(fn + 9, "JPG", 3)) continue;
            if (fn[0] == '_') continue;	/* IvVt@C𖳎 */
	    if (strncmp(fn + 4, "0001", 4) <= 0 || strncmp(fn + 4, "9999", 4) > 0) continue;
            if (fnumber >= nth && fnumber < nth + nfiles) {
		pdcf->flag = 1;
		strcpy(pdcf->pathname, dirpath);
		strcpy(pdcf->pathname + 14, "/");
		strcpy(pdcf->pathname + 15, fn);
		pdcf->fsize = dcfdir_finfo.fsize;
		res = f_open(&jpegfile, pdcf->pathname, FA_READ);
		if (res == FR_OK) {
		    CollectExif(&jpegfile, &pdcf->exif_info);
		    f_close(&jpegfile);
		}
		pdcf++;
	        num_read++;
	    }
	    fnumber++;
	    if (num_read == nfiles)
	        break;
	}
    }
    return nfiles;
}


/*
 * SDJ[h DCFfBNg̐ƁA̒DCFt@C̐߂B
 * (݂́AfBNg͎ۂɂ͎gpĂȂ)
 */
FRESULT scan_DCF ()
{
    FRESULT res;
    BYTE i;
    char *fn;
    DIR dirs, dcfdir;
    char dirpath[16];
    FILINFO dir_finfo, dcfdir_finfo;
    struct dcf_file_info *pdcf;
    FIL  jpegfile;

    strcpy(dirpath, "/DCIM/");
    res = f_opendir(&dirs, "/DCIM");	/* fBNgJ */

    if (res != FR_OK)
        return res;

    dcf_info.findex = -1;
    dcf_info.nfiles = 0;
    dcf_info.num_dirs = dcf_info.num_files = 0;

    memset(&dcf_files[0], 0, sizeof(struct dcf_file_info)*DCF_BUF_SIZE);

    pdcf = dcf_files;
    while (((res = f_readdir(&dirs, &dir_finfo)) == FR_OK) && dir_finfo.fname[0]) {
	fn = dir_finfo.fname;	/* LFN\ł͏SFN */
	if (!(dir_finfo.fattrib & AM_DIR)) continue;	/* Skip non directory file */
        /*
         * DCFfBNg̍ŏ3 "000"`"999"łȂ΂ȂȂ
         */
        if (strncmp(fn, "100", 3) < 0 || strncmp(fn, "999", 3) > 0) continue;
        i = strlen(fn);
	if (i != 8) continue;
        dcf_info.num_dirs++;
	strcpy(dirpath + 6, fn);
	dirpath[6 + i] = '\0';

	res = f_opendir(&dcfdir, dirpath);

        while (((res = f_readdir(&dcfdir, &dcfdir_finfo)) == FR_OK) && dcfdir_finfo.fname[0]) {
	    fn = dcfdir_finfo.fname;	/* LFN\ł͏SFN */
	    if (dcfdir_finfo.fattrib & AM_DIR) continue;
	    if (strlen(fn) != 12) continue;
	    if (strncmp(fn + 9, "JPG", 3)) continue;
            if (fn[0] == '_') continue;	/* IvVt@C𖳎 */
	    if (strncmp(fn + 4, "0001", 4) <= 0 || strncmp(fn + 4, "9999", 4) > 0) continue;
	    if (dcf_info.findex < 0) dcf_info.findex = 0;
	    if (dcf_info.nfiles < DCF_BUF_SIZE) {
		pdcf->flag = 1;
		strcpy(pdcf->pathname, dirpath);
		strcpy(pdcf->pathname + 14, "/");
		strcpy(pdcf->pathname + 15, fn);
		pdcf->fsize = dcfdir_finfo.fsize;
#ifdef XDEBUG
xprintf("%x: %s\n", pdcf, pdcf->pathname);
#endif
		res = f_open(&jpegfile, pdcf->pathname, FA_READ);
		if (res == FR_OK) {
		    CollectExif(&jpegfile, &pdcf->exif_info);
		    f_close(&jpegfile);
		}
		pdcf++;
		dcf_info.nfiles++;
	    }
	    dcf_info.num_files++;
	}
    }
#ifdef XDEBUG
xprintf("nfiles = %d\n", dcf_info.nfiles);
#endif

    return res;
}

#define	N_PROGRAM 9

char *exp_programs[N_PROGRAM] = {
  "Undef",
  "ƭ",
  "۸",
  "iD",
  "D",
  "creative",
  "action",
  "l",
  "i",
};

#define	N_LIGHT	24
char *light_sources[N_LIGHT] = {
  "s", "", "u", "d", "tbV",	/* 0 .. 4 */
  "̑", "̑", "̑", "̑",		/* 5 .. 8 */
  "V", "ܓV", "A", "Fu",		/* 9 .. 12 */
  "Fu", "Fu", "Fu",		/* 13, 14, 15 */
  "̑",						/* 16 */
  "WA", "WB", "WC",			/* 17, 18, 19 */
  "D55", "D65", "D75", "D50",				/* 20 .. 23 */
};

#define	N_METERING	7
char *metering_modes[N_METERING] = {
  "s",
  "",
  "d_",
  "X|bg",
  "߯",
  "",
  "",
};

char *flash_modes[] = {
  "s",
  "",
  "֎~",
  "",
};

char *flash_results[] = {
  "",
  "L"
};

char *exp_modes[] = {
  "",
  "}jA",
  "ׯ",
  "\",
};

char *wb_modes[] = {
  "",
  "}jA",
};

#define	USE_K14
#ifdef	USE_K16
#define	EXIF_COL1	21
#define	EXIF_COL2	21
#define	EXIF_ROW1	0
#define	EXIF_ROW2	8
#define	EXIF_ROW3	10
#define	EXIF_ROW4	11
#else
#ifdef USE_K14
#define	EXIF_COL1	24
#define	EXIF_COL2	21
#define	EXIF_ROW1	0
#define	EXIF_ROW2	9
#define	EXIF_ROW3	11
#define	EXIF_ROW4	12
#else
#define	EXIF_COL1	28
#define	EXIF_COL2	21
#define	EXIF_ROW1	0
#define	EXIF_ROW2	12
#define	EXIF_ROW3	14
#define	EXIF_ROW4	15
#endif
#endif

void decode_gps_degree(long *lp)
{
  if (lp[1] != 1) {
    switch (lp[1]) {
    case 10:
      t_printf("%3d.%d", lp[0]/10, lp[0]%10);
      break;
    case 100:
      t_printf("%3d.%02d", lp[0]/100, lp[0]%100);
      break;
    default:
      t_printf("%3d", lp[0]/lp[1]);
      break;
    }
    return;
  }
  t_printf("%3d", lp[0]);
  lp += 2;
  if (lp[1] != 1) {
    switch (lp[1]) {
    case 10:
      t_printf("%2d.%d'", lp[0]/10, lp[0]%10);
      break;
    case 100:
      t_printf("%2d.%02d'", lp[0]/100, lp[0]%100);
      break;
    default:
      t_printf("%2d'", lp[0]/lp[1]);
      break;
    }
    return;
  }
  t_printf("%2d'", lp[0]);
  lp += 2;
  if (lp[1] != 1) {
    switch (lp[1]) {
    case 10:
      t_printf("%2d.%d\"", lp[0]/10, lp[0]%10);
      break;
    case 100:
      t_printf("%2d.%02d\"", lp[0]/100, lp[0]%100);
      break;
    case 1000:
      t_printf("%2d.%03d\"", lp[0]/1000, lp[0]%1000);
      break;
    default:
      t_printf("%2d\"", lp[0]/lp[1]);
      break;
    }
    return;
  }
  t_printf("%2d\"", lp[0]);
}

/*
 * Exif\
 */
void show_exif(char *pathname, EXIF *exif)
{
    char *str;
    int mode;
    int divisor, val;

    GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
    GRPH_Clear(C_BLACK);
    if (exif->no_app1) {
	GCON_locate (2, 7);
	t_printf("̃t@CExif`ł͂܂");
		ev_get(1);
	return;
    }
    /*
     * TlC摜̐L/\
     */
    expand_thumbnail(pathname, exif->thumb_offset, -1);

    /* ISOx\ */
    if (exif->iso_speed) {
    	GCON_set_color(C_BLACK, C_WHITE);
    	GCON_locate(EXIF_COL1, 0); t_printf("ISO");
    	GCON_set_color(C_WHITE, C_BLACK);
    	t_printf(" %d", exif->iso_speed);
    }
    /* Fio\ */

    if (exif->f_number[0]) {
	GCON_locate(EXIF_COL1, 1);
    	switch (exif->f_number[1]) {
	case 10:
	    t_printf("F%d.%d", exif->f_number[0]/10, exif->f_number[0] % 10);
	    break;
	case 100:
	    t_printf("F%d.%02d", exif->f_number[0]/100, exif->f_number[0] % 100);
	    break;
    	default:
	    t_printf("F%d/%03d", exif->f_number[0], exif->f_number[1]);
	    break;
	}
    }
     if (exif->exp_time[0]) {
    	/* Iԕ\ */
    	t_printf("  %d/%db", exif->exp_time[0], exif->exp_time[1]);
    }

    /* œ_\ */
    divisor = exif->focal_length[1];
    val = exif->focal_length[0]%divisor;
    while (val > 10 && ((val % 10) == 0))
	val /= 10;
    GCON_locate(EXIF_COL1, 2);
    t_printf("œ_: %d.%dmm", exif->focal_length[0]/divisor, val);

    if (exif->exp_program) {	/* Be[h */
        if (exif->exp_program < N_PROGRAM)
	    str = exp_programs[exif->exp_program];
        else
	    str = "̑";
        GCON_locate(EXIF_COL1, 3);
        t_printf("BeӰ: %s", str);
    }
    if (exif->metering) {	/*  */
        if (exif->metering < N_METERING)
	    	str = metering_modes[exif->metering];
        else
	    	str = "̑";
        GCON_locate(EXIF_COL1, 4);
        t_printf(": %s", str);
    }
    if (exif->light_source) {	/*  */
        if (exif->light_source < N_LIGHT)
	    	str = light_sources[exif->light_source];
        else
	    	str = "̑";
        GCON_locate(EXIF_COL1, 5);
        t_printf(": %s", str);
    }

    /* Io */
    GCON_locate(EXIF_COL1, 6);
    t_printf("Io: %s", exp_modes[exif->exp_mode & 3]);

    /* zCgoX */
    GCON_locate(EXIF_COL1, 7);
    t_printf("WB: %s", wb_modes[exif->wb_mode & 1]);

    GCON_locate(0, EXIF_ROW2);
    t_printf("f: %d X %d (%d)\n",
		exif->image_width, exif->image_height, exif->orientation);
    if (exif->resolution[1] == 1) {
        t_printf("𑜓x: 1/%d%s", exif->resolution[0],
			(exif->resolution_unit == 1)? "cm" : "inch");
    } else {
        t_printf("𑜓x: 1/%d%s", exif->resolution[0]/exif->resolution[1],
			(exif->resolution_unit == 1)? "cm" : "inch");
   }


    mode = (exif->flash >> 3) & 3;
    str = flash_modes[mode];
    GCON_locate(0, EXIF_ROW3);
    t_printf("tbV: %s", str);
    if (mode == 3) {
		t_printf(" (%s)", flash_results[exif->flash&1]);
    }

    GCON_locate(0, EXIF_ROW4);
#ifdef USE_K16
    t_printf("[J: %s f: %s\n", exif->maker, exif->model);
#else
    t_printf("[J: %s\nf: %s\n", exif->maker, exif->model);
#endif
    t_printf("Be: %s\n", exif->date_time);
    if (exif->GPSVersionID) {
        t_printf("GPS: %s", exif->GPSLatitudeRef);
        decode_gps_degree(&exif->GPSLatitude[0]);
        t_printf(" %s", exif->GPSLongitudeRef);
        decode_gps_degree(&exif->GPSLongitude[0]);
        t_printf("\n");
        if (exif->GPSAltitude[1]) {
          val = exif->GPSAltitude[0]/exif->GPSAltitude[1];
          if (exif->GPSAltitudeRef) val = -val;
          t_printf("     %dm", val);
        }
        if (exif->GPSImgDirection[1]) {
          val = exif->GPSImgDirection[0]/exif->GPSImgDirection[1];
          t_printf(" %s%d", exif->GPSImgDirectionRef, val);
        }
    }
}

evinfo saved_event;

void ev_save(evinfo *evp)
{
    saved_event = *evp;
}

void ev_clear()
{
    saved_event.ev_time = 0;
}

int find_touch_event(evinfo *evp)
{
    int xdiff, ydiff;
    int xabs, yabs;
    int event;

    if (evp->ev_time - saved_event.ev_time > 1000) {
	return EV_NOP;
    }

    xabs = xdiff = evp->xpos - saved_event.xpos;
    yabs = ydiff = evp->ypos - saved_event.ypos;

    if (xdiff < 0) xabs = -xdiff;
    if (ydiff < 0) yabs = -ydiff;

    if (xabs > 80 || yabs > 60) {	/* XN[wƔ肷 */
	/* ړʂ̑𔻒ɗp */
	if (yabs > xabs) {
	    event = (ydiff < 0)? EV_SCROLL_DOWN : EV_SCROLL_UP;
	} else {
	    event = (xdiff < 0)? EV_SCROLL_DOWN : EV_SCROLL_UP;
	}
	return event;
    }
    return EV_NOP;
}

#ifdef USE_K16
#define	THUM_ROW1	12
#else
#ifdef USE_K14
#define	THUM_ROW1	14
#else
#define	THUM_ROW1	16
#endif
#endif

void dcf_viewer()
{
    FRESULT res;
    int need_read, need_draw, nfiles;
    int gotev, cpos, ppos;
    int xpos, ypos, picpos;
    int dlen, event;
    struct dcf_file_info *pdcf;
    EXIF *exif;
    int thumb_top;    /* ŏɕ\Ă摜̔ԍ */
    evinfo *evp;
    UINT sel_time;
    char temp_buffer[40];

    /* J[h DCFfBNg̐ƁA̒DCFt@C̐߂B*/
    res = scan_DCF ();

    if (res != FR_OK)
        return;
#ifdef DEBUG
    xprintf("dirs: %d, files: %d\n", dcf_info.num_dirs, dcf_info.num_files);
#endif

    if (dcf_info.num_files == 0) {    /* No file??? */
        /* XXX  Need to show error message */
        return;
    }
    thumb_top = 0;
    need_read = 1;
    need_draw = 0;
    nfiles = cpos = 0;

    do {
        if (need_read) {
            nfiles = seek_DCF(thumb_top);
            need_read = 0;
            need_draw = 1;
        }
        if (need_draw) { /* TlC摜\Kv */
            /* OtBbNXv[I */
            GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
            GRPH_Clear(C_BLACK);        /* OtBNẌNA */

            /* TlC摜 nfiles\ */
            pdcf = &dcf_files[0];
            for (picpos = 0; picpos < nfiles; picpos++) {
              expand_thumbnail(pdcf->pathname, pdcf->exif_info.thumb_offset, picpos);
              pdcf++;
            }
            need_draw = 0;
        }

        /* cpos ̈ʒuɉ摜IJ[\\(eLXgv[) */
        xpos = 80 * (cpos % 4);
        ypos = 60 * (cpos / 4);

        GRPH_Box(xpos,   ypos,   xpos + 80 - 1, ypos + 60 - 1, C_WHITE, 0);
        GRPH_Box(xpos+1, ypos+1, xpos + 80 - 2, ypos + 60 - 2, C_WHITE, 0);
        GRPH_Box(xpos+2, ypos+2, xpos + 80 - 3, ypos + 60 - 3, C_BLACK, 0);
        GRPH_Box(xpos+3, ypos+3, xpos + 80 - 4, ypos + 60 - 4, C_BLACK, 0);

        sel_time = get_time_tick();

        pdcf = &dcf_files[cpos];
        exif = &pdcf->exif_info;

        /* IĂ摜Ɋւ\ */
#ifdef DEBUG
    xprintf("%d: %s (%d)\n", dcf_info.findex + cpos, pdcf->pathname, pdcf->fsize);
#endif
        GCON_locate(0, THUM_ROW1);
        t_printf("t@C: %s\n", pdcf->pathname);

        GCON_clear_line(THUM_ROW1+1);
        GCON_clear_line(THUM_ROW1+2);

        if (exif->no_app1 == 0) {
            t_printf("Be: %s\n", exif->date_time);
            t_printf("f: %d X %d (%d)",
            exif->image_width, exif->image_height, exif->orientation);
        }
        t_sprintf(temp_buffer, "%d/%d",
            dcf_info.findex + cpos + 1, dcf_info.num_files);
        dlen = strlen(temp_buffer);
        GCON_locate(40 - dlen - 1, THUM_ROW1+2);
        t_puts(temp_buffer);

        ppos = cpos;

        /* ͂ꂽCxgɑΉANVs */
        do {
            gotev = 1;

            evp = ev_get(1);
            event = evp->ev_type;

            if (event == EV_PENDOWN) {
                int xpos, ypos, tpos;
                UINT tdiff;

                xpos = evp->xpos;
                ypos = evp->ypos;

                ev_save(evp);
                if (ypos < 180) {
                  tpos = ypos / 60 * 4 + xpos / 80;
                  if (tpos == cpos) {
                    /*
                     * łɑIς݂̉摜^b`ꂽ
                     * IĂ̌oߎԂŃANV肷
                     */
                    tdiff = get_time_tick() - sel_time;
                    if (tdiff > 850)         /* 850msȏo߂͖ */
                        event = EV_NOP;
                    else if (tdiff < 350)    /* 350msȉŃXChV[ */
                        event = EV_SEL_LEFT;
                    else
                        event = EV_SEL_RIGHT;    /* ȊO 摜\ */
                  } else {
                    if (dcf_info.findex + tpos < dcf_info.num_files) {
                        cpos = tpos;    /* I摜ύX */
                    }
                    event = EV_PENDOWN;
                  }
                } else {
                    gotev = 0;
                }
            } else if (event == EV_PENUP) {
		event = find_touch_event(evp);
	    }

            switch (event) {
            case EV_SCROLL_UP:	/* Õy[W̍Ō̉摜ֈړ */
    	        if (dcf_info.findex > 0)
    	            cpos = -1;
    	        break;
            case EV_SCROLL_DOWN: /* ̃y[W̍ŏ̉摜ֈړ */
	        if (dcf_info.findex + 12 < dcf_info.num_files)
    	            cpos = 12;
    	        break;
            case EV_UP_KEY:	/* O̍sɈړ */
                if (dcf_info.findex + cpos >= 4) cpos -= 4;
	            break;
            case EV_DOWN_KEY:	/* ̍sɈړ */
                if (dcf_info.findex + cpos + 4 < dcf_info.num_files) cpos += 4;
                break;
            case EV_LEFT_KEY:	/* ÖʒuɈړ */
                if (cpos == 0 && dcf_info.findex == 0)
                    break;
                cpos--;
                break;
            case EV_RIGHT_KEY:	/* ̈ʒuɈړ */
                if (dcf_info.findex + cpos + 1 == dcf_info.num_files)
    	    	    break;
                cpos++;
                break;
            case EV_SEL_RIGHT:	/* SEL_RIGHT Sʂɉ摜\ */
                GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
                GRPH_Clear(C_BLACK);

    	        if (expand_jpeg(pdcf->pathname, exif) == 0) {
    	            GCON_locate(5, 7);
		    t_puts("摜傫ĕ\ł܂");
		    delay_ms(300);
	        }
	        ev_flush();
	        ev_clear();
	        evp = ev_get(1);
	        if (evp->ev_type == EV_PENDOWN || evp->ev_type == EV_SEL_RIGHT) {
	            show_exif(pdcf->pathname, exif);
                    delay_ms(500);
                    ev_flush();
                    do {
                       evp = ev_get(1);
                    } while (evp->ev_type != EV_PENUP && evp->ev_type != EV_SEL_RIGHT);
	        }
	        need_draw = 1;
	        break;
            case EV_SEL_LEFT:	/* SEL_LEFT XChV[Jn */
	        cpos = slide_show(cpos);
	        thumb_top = dcf_info.findex;
	        need_read = 1;
	        need_draw = 1;
	        break;
	    case EV_PENDOWN:
                break;
	    case EV_NOP:
	    default:
	        gotev = 0;
	        break;
	    }
        } while (gotev == 0);

        if (event == EV_SEL_RIGHT || event == EV_SEL_LEFT) {
	    /* TlC摜\Kv */
	    continue;
        }

        if (ppos != cpos) {
            /* 摜IJ[\ */
            xpos = 80 * (ppos % 4);
            ypos = 60 * (ppos / 4);
            pdcf = &dcf_files[ppos];
            /* J[\ŉBĂ𕜌邽߂ɍĕ` */
            expand_thumbnail(pdcf->pathname, pdcf->exif_info.thumb_offset, ppos);
        }

	if (cpos < 0) {
	    thumb_top -= 12;
	    cpos += 12;
	    need_read = 1;
	}
	if (cpos >= 12) {
	    thumb_top += 12;
	    cpos -= 12;
            need_read = 1;
	}
    } while (1);
}
