#ifndef __EXIF_H__
#define	__EXIF_H__
#define	EXIF_ORGDATE_LEN	(20+1)		/* Add one for terminating NUL */
#define	EXIF_STR_LEN	20

typedef struct {
  short compression;
  short orientation;
  short exp_program;
  short exp_mode;
  short wb_mode;
  short iso_speed;
  short metering;
  short light_source;
  short flash;
  short resolution_unit;
  short no_app1;
  long exp_time[2];
  long f_number[2];
  long focal_length[2];
  long resolution[2];
  int image_width, image_height;
  long thumb_offset;

  long GPSVersionID;
  char GPSLatitudeRef[2];
  char GPSLongitudeRef[2];
  char GPSImgDirectionRef[2];
  short GPSAltitudeRef;
  long GPSLatitude[2];
  long GPSLatitudeMM[2];
  long GPSLatitudeSS[2];
  long GPSLongitude[2];
  long GPSLongitudeMM[2];
  long GPSLongitudeSS[2];
  long GPSAltitude[2];
  long GPSImgDirection[2];

  char maker[EXIF_STR_LEN+1];
  char model[EXIF_STR_LEN+1];
  char date_time[EXIF_ORGDATE_LEN];
} EXIF;

int CollectExif(FIL *fp, EXIF *exif);
#endif	/* __EXIF_H__ */
