/*
 * 摜\ɎgpTu[`Q
 */
//#include "ff.h"
//#include "viewer.h"
#include "../lcdtext/graphics.h"

void TransferToGRAM(void *src, void *dst, int cnt)
{
    unsigned short *ssrc, *sdst;

    ssrc = (unsigned short *)src;
    sdst = (unsigned short *)dst;

    while (cnt-- > 0) *sdst++ = *ssrc++;
}

/*
 *   orientaiton ɉāÂ悤ȏԂŉf\B
 *
 *   1. EցA̍s牺̍sցB
 *       ------>
 *       |
 *       |
 *       V
 *
 *   2. E獶ցA̍s牺̍sցB
 *       <------
 *       |
 *       |
 *       V
 *
 *   3. E獶ցA̍s̍sցB
 *             ^
 *             |
 *             |
 *       <------
 *    
 *   4. EցA̍s̍sցB
 *       ^
 *       |
 *       |
 *       ------>
 *
 *   5. ォ牺ցA̗񂩂E̗ցB
 *       |------>
 *       |
 *       V
 *
 *   6. ォ牺ցAE̗񂩂獶̗ցB
 *       <------|
 *              |
 *              V
 *
 *   7. ցAE̗񂩂獶̗ցB
 *       <------^
 *              |
 *              |
 *
 *   8. ցA̗񂩂E̗ցB
 *      ^
 *      |
 *      |------->
 *
 */

static PIXEL line_buffer[LCD_WIDTH];

void LCD_Draw_Line(int orientation, unsigned char *bp, int xoffset, int ypos, int width)
{
	PIXEL *pix, *lp;
        unsigned char rval, gval, bval;
        int nb;

	switch (orientation) {
	case 1:	/* EցA̍s牺̍sցB*/
	default:
	    pix = (PIXEL *)GRPH_Buffer + ypos * LCD_WIDTH + xoffset;
            lp = line_buffer;
	    for (nb = width; nb > 0; nb--) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*lp++ = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
	    }
            TransferToGRAM(line_buffer, pix, width);
	    break;
	case 2: /* E獶ցA̍s牺̍sցB*/
	    pix = (PIXEL *)GRPH_Buffer + (ypos + 1) * LCD_WIDTH - xoffset - 1;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix-- = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
	    }
	    break;
	case 3: /* E獶ցA̍s̍sցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_HEIGHT - ypos)* LCD_WIDTH - 1 - xoffset;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix-- = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
	    }
	    break;
	case 4: /* EցA̍s̍sցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_HEIGHT -1 - ypos)* LCD_WIDTH + xoffset;
            lp = line_buffer;
	    for (nb = width; nb > 0; nb--) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*lp++ = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
	    }
            TransferToGRAM(line_buffer, pix, width);
	    break;
	case 5: /* ォ牺ցA̗񂩂E̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer + ypos + (LCD_HEIGHT * xoffset);
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix += LCD_WIDTH;
	    }
	    break;
	case 6: /* ォ牺ցAE̗񂩂獶̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_WIDTH -1) - ypos + (LCD_HEIGHT * xoffset);
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix += LCD_WIDTH;
	    }
	    break;
	case 7:	/* ցAE̗񂩂獶̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer - 1 + (LCD_HEIGHT - xoffset)*LCD_WIDTH - ypos;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix -= LCD_WIDTH;
	    }
	    break;
	case 8:	/* ցA̗񂩂E̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_HEIGHT - 1 - xoffset)*LCD_WIDTH + ypos;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix -= LCD_WIDTH;
	    }
	    break;
	}
}
