/*------------------------------------------------------------------------*/
/* FRK-RX62N: MMCv3/SDv1/SDv2 (SPI[h) 䃂W[                   */
/*------------------------------------------------------------------------*/
/*
/  Copyright (C) 2011, ChaN, all right reserved.
/
/ * This software is a free software and there is NO WARRANTY.
/ * No restriction on use. You can use, modify and redistribute it for
/   personal, non-profit or commercial products UNDER YOUR RESPONSIBILITY.
/ * Redistributions of source code must retain the above copyright notice.
/
/-------------------------------------------------------------------------*/

//#define	USE_CRC16

#define RSPI_CH	0	/* gpSPI|[g̑I: 0:RSPIA-A, 1:RSPIB-A, 10:RSPIA-B, 11:RSPIB-B */	

#define	CS_LOW()	{PORTC.DR.BIT.B4 = 0;}	/* CS#Lɂ */
#define	CS_HIGH()	{PORTC.DR.BIT.B4 = 1;}	/* CS#Hɂ */
#define	INS			(!PORT0.PORT.BIT.B7)	/* J[ho(^:, U:Ȃ) */
#ifdef USE_WP
#define	WP			0 //(PORT0.PORT.BIT.B5)	/* ݋֎~(^:֎~, U:) */
#define CS_INIT()	{	/* CS#,INS#,WP e[q̏ */\
	PORTC.DR.BIT.B4 = 1; /* CS#=OUT */	\
	PORTC.DDR.BIT.B4 = 1; /* CS#=H */	\
	PORT0.ICR.BIT.B7 = 1; /* INS#=IN */	\
	PORT0.ICR.BIT.B5 = 1; /* WP=IN */	\
}
#else
#define CS_INIT()	{	/* CS#,INS#,WP e[q̏ */\
	PORTC.DR.BIT.B4 = 1; /* CS#=OUT */	\
	PORTC.DDR.BIT.B4 = 1; /* CS#=H */	\
	PORT0.ICR.BIT.B7 = 1; /* INS#=IN */	\
}
#endif

#define PCLK		48000000UL	/* PCLK̎g[Hz] */
#define CLK_FAST	16000000UL	/* SCLK̎g[Hz] (쒆) */
#define	CLK_SLOW	400000UL	/* SCLK̎g[Hz] () */

/*------------------------------------------------------------------------*/


#if RSPI_CH == 0	/* RSPIA-A */
#define RSPI	RSPI0
#define	SPI_ATTACH() {			\
	PORTC.ICR.BIT.B7 = 1;		\
	IOPORT.PFGSPI.BYTE = 0x0E;	\
	MSTP_RSPI0 = 0;				\
}

#elif RSPI_CH == 10	/* RSPIA-B */
#define RSPI	RSPI0
#define	SPI_ATTACH() {			\
	PORTA.ICR.BIT.B7 = 1;		\
	IOPORT.PFGSPI.BYTE = 0x0F;	\
	MSTP_RSPI0 = 0;				\
}

#elif RSPI_CH == 1	/* RSPIB-A */
#define RSPI	RSPI1
#define	SPI_ATTACH() {			\
	PORT3.ICR.BIT.B0 = 1;		\
	IOPORT.PFHSPI.BYTE = 0x0E;	\
	MSTP_RSPI1 = 0;				\
}

#elif RSPI_CH == 11	/* RSPIB-B */
#define RSPI	RSPI1
#define	SPI_ATTACH() {			\
	PORTE.ICR.BIT.B7 = 1;		\
	IOPORT.PFHSPI.BYTE = 0x0F;	\
	MSTP_RSPI1 = 0;				\
}

#endif

#define FCLK_FAST() {					\
	RSPI.SPCR.BIT.SPE = 0;				\
	RSPI.SPBR.BYTE = PCLK/2/CLK_FAST-1;	\
	RSPI.SPCR.BIT.SPE = 1;				\
}

#ifdef __LIT
#define LDDW(x) revl(x)	/* gGfBÂƂ32rbgt[̃oCgXbv */
#else
#define LDDW(x) x		/* rbOGfBÂƂ32rbgt[̃oCgXbvȂ */
#endif



/*--------------------------------------------------------------------------

   vCx[g֐E[NGA

---------------------------------------------------------------------------*/

#include <machine.h>
#include "iodefine.h"
#include "../fatfs/diskio.h"
#include "../lcdtext/touch.h"


/* MMC/SD command */
#define CMD0	(0)			/* GO_IDLE_STATE */
#define CMD1	(1)			/* SEND_OP_COND (MMC) */
#define	ACMD41	(0x80+41)	/* SEND_OP_COND (SDC) */
#define CMD8	(8)			/* SEND_IF_COND */
#define CMD9	(9)			/* SEND_CSD */
#define CMD10	(10)		/* SEND_CID */
#define CMD12	(12)		/* STOP_TRANSMISSION */
#define ACMD13	(0x80+13)	/* SD_STATUS (SDC) */
#define CMD16	(16)		/* SET_BLOCKLEN */
#define CMD17	(17)		/* READ_SINGLE_BLOCK */
#define CMD18	(18)		/* READ_MULTIPLE_BLOCK */
#define CMD23	(23)		/* SET_BLOCK_COUNT (MMC) */
#define	ACMD23	(0x80+23)	/* SET_WR_BLK_ERASE_COUNT (SDC) */
#define CMD24	(24)		/* WRITE_BLOCK */
#define CMD25	(25)		/* WRITE_MULTIPLE_BLOCK */
#define CMD32	(32)		/* ERASE_ER_BLK_START */
#define CMD33	(33)		/* ERASE_ER_BLK_END */
#define CMD38	(38)		/* ERASE */
#define CMD55	(55)		/* APP_CMD */
#define CMD58	(58)		/* READ_OCR */


static volatile
DSTATUS Stat = STA_NOINIT;	/* Physical drive status */

static volatile
WORD Timer1, Timer2;	/* 100Hz decrement timer stopped at zero (disk_timerproc()) */

static
BYTE CardType;			/* Card type flags */



/*-----------------------------------------------------------------------*/
/* MMC/SDC1oCgM (vbgtH[ˑ)                           */
/*-----------------------------------------------------------------------*/

/* 1oCgM */
static
void xmit_spi (
	BYTE dat	/* Mf[^ */
)
{
	RSPI.SPDR.LONG = dat;			/* MJn */
	while (!RSPI.SPSR.BIT.SPRF) ;	/* ]҂ */
	RSPI.SPDR.LONG;					/* Mf[^͊Ă */
}


/* oCg̑M (RTOSłDMA) */
static
void xmit_spi_multi (
	const BYTE *buff,	/* f[^obt@ւ̃|C^ */
	UINT btx			/* MoCg (4̔{) */
)
{
	const DWORD *lp = (const DWORD*)buff;


	RSPI.SPCMD0.BIT.SPB = 3;	/* t[32-bitɐݒ */

	do {
		RSPI.SPDR.LONG = LDDW(*lp++);	/* 4oCgMJn */
		while (!RSPI.SPSR.BIT.SPRF) ;	/* ]҂ */
		RSPI.SPDR.LONG;					/* Mf[^͊Ă */
	} while (btx -= 4);					/* KvȂJԂ */

	RSPI.SPCMD0.BIT.SPB = 7;	/* t[8-bitɖ߂ */
}



/*-----------------------------------------------------------------------*/
/* MMCf[^M  (vbgtH[ˑ)                       */
/*-----------------------------------------------------------------------*/

/* 1oCgM */
static
BYTE rcvr_spi (void)
{
	RSPI.SPDR.LONG = 0xFF;			/* 0xFF𑗐M */
	while (!RSPI.SPSR.BIT.SPRF) ;	/* ]I҂ */
	return RSPI.SPDR.LONG;			/* ꂽoCgԂ */
}

/* oCg̎M (RTOSłDMA) */
static
void rcvr_spi_multi (
	BYTE *buff,		/* f[^obt@ւ̃|C^ */
	UINT btr		/* MoCg (4̔{) */
)
{
	DWORD *lp = (DWORD*)buff;


	RSPI.SPCMD0.BIT.SPB = 3;	/* t[32-bitɐݒ */

	do {
		RSPI.SPDR.LONG = 0xFFFFFFFF;	/* MDOHɕۂ */
		while (!RSPI.SPSR.BIT.SPRF) ;	/* ]҂ */
		*lp++ = LDDW(RSPI.SPDR.LONG);	/* M4oCgXgA */
	} while (btr -= 4);					/* KvȂJԂ */

	RSPI.SPCMD0.BIT.SPB = 7;	/* t[8-bitɖ߂ */
}




/*-----------------------------------------------------------------------*/
/* MMC/SDC̓҂                                           */
/*-----------------------------------------------------------------------*/

static
int wait_ready (	/* 1:OK, 0:^CAEg */
	UINT wt			/* ^CAEg [ms] */
)
{
	Timer2 = (WORD)wt;

	rcvr_spi();		/* 1oCgǂ (DOo͂m肳) */
	do {
		if (rcvr_spi() == 0xFF) return 1;	/* fBԂɂȂ */
		/* ̃[v͂xԂv. RTOSł͓KXrot_rdq()}. */
	} while (Timer2);	/* ^CAEg܂Ń[v */

	return 0;	/* ^CAEg */
}



/*-----------------------------------------------------------------------*/
/* MMC/SDCfBZNgSPI                                      */
/*-----------------------------------------------------------------------*/

static
void deselect (void)
{
	CS_HIGH();		/* CS = H */
	rcvr_spi();		/* _~[NbN𑗂, DOo͂Hi-Zɂ */
}



/*-----------------------------------------------------------------------*/
/* J[hIfBԂmF                                        */
/*-----------------------------------------------------------------------*/

static
int select (void)	/* 1:OK, 0:^CAEg */
{
	CS_LOW();		/* CS = L */
	if (!wait_ready(500)) {
		deselect();
		return 0;	/* J[hrW[ԂŃ^CAEg */
	}
	return 1;	/* OK */
}



/*-----------------------------------------------------------------------*/
/* SPIW[̐ (vbgtH[ˑ)                            */
/*-----------------------------------------------------------------------*/

static
void power_on (void)	/* SPI|[g̏ */
{
	CS_INIT();	/* CS[q̗L */

	/* RSPIW[I/Opbhɐڑ */
	SPI_ATTACH();

	/* RSPIW[̏ */
	RSPI.SPCR.BYTE = 0;		/* Stop SPI */
	RSPI.SPPCR.BYTE = 0;	/* Fixed idle value, disable loop-back mode */
	RSPI.SPSCR.BYTE = 0;	/* Disable sequence control */
	RSPI.SPDCR.BYTE = 0x20;	/* SPLW=1 */
	RSPI.SPCMD0.WORD = 0x0700;	/* LSBF=0, SPB=7, BRDV=0, CPOL=0, CPHA=0 */
	RSPI.SPBR.BYTE = PCLK / 2 / CLK_SLOW - 1;	/* Bit rate */
	RSPI.SPCR.BYTE = 0x49;	/* Start SPI in master mode */
}


static
void power_off (void)	/* SPI|[g̊J */
{
	select();				/* MMC/SDC̓҂ */
	deselect();

	RSPI.SPCR.BYTE = 0;		/* RSPIW[̒~ */
}

#ifdef USE_CRC16
int crc_err_count;

USHORT check_crc(BYTE *ptr, int cnt, int crc1, int crc2)
{
  USHORT val;

  CRC.CRCCR.BYTE = 0x87;
  while (cnt-- > 0)
    CRC.CRCDIR = *ptr++;
  CRC.CRCDIR = crc1;
  CRC.CRCDIR = crc2;
  val = CRC.CRCDOR;
  if (val)
    crc_err_count++;
  return val;
}
#endif

/*-----------------------------------------------------------------------*/
/* MMC/SDCf[^EpPbgM                                 */
/*-----------------------------------------------------------------------*/

static
int rcvr_datablock (	/* 1:, 0:s */
	BYTE *buff,			/* f[^obt@ւ̃|C^ */
	UINT btr			/* f[^ubN [byte] */
)
{
	BYTE token;
	BYTE crc1, crc2;
        USHORT crcval;


	Timer1 = 200;
	do {							/* DataStartg[N҂(ő200ms) */
		token = rcvr_spi();
		/* ̃[v͂xԂv. RTOSł͓KXrot_rdq()}. */
	} while ((token == 0xFF) && Timer1);
	if(token != 0xFE) {
		return 0;		/* DataStartg[NȊO̎M܂̓^CAEg */
	}
	rcvr_spi_multi(buff, btr);		/* g[Nɑf[^ubNXgA */
	crc1 = rcvr_spi();
	crc2 = rcvr_spi();			/* f[^CRC͊Ă */
#ifdef USE_CRC16
    crcval = check_crc(buff, btr, crc1, crc2);
    return (crcval == 0);
#else
    return 1;	/* OK */
#endif
}



/*-----------------------------------------------------------------------*/
/* MMC/SDCɃf[^pPbg𑗐M                                     */
/*-----------------------------------------------------------------------*/

#if _READONLY == 0
static
int xmit_datablock (	/* 1:, 0:s */
	const BYTE *buff,	/* Mf[^(512oCg)ւ̃|C^ */
	BYTE token			/* gpg[N */
)
{
	BYTE resp;


	if (!wait_ready(500)) return 0;		/* J[h̓҂ */

	xmit_spi(token);					/* g[N̑M */
	if (token != 0xFD) {				/* StopTrang[NȊO̎͑ăf[^𑗐M  */
		xmit_spi_multi(buff, 512);		/* f[^ */
		xmit_spi(0xFF); xmit_spi(0xFF);	/* _~[CRC */

		resp = rcvr_spi();				/* f[^X|X̎M */
		if ((resp & 0x1F) != 0x05)		/* ɎMꂽ? */
			return 0;	/* s */
	}
	return 1;	/*  */
}
#endif /* _READONLY */



/*-----------------------------------------------------------------------*/
/* MMC/SDCɃR}hpPbg𑗐M                                       */
/*-----------------------------------------------------------------------*/

static
BYTE send_cmd (		/* ߂l: R1X|X (bit71̂Ƃ͑Ms) */
	BYTE cmd,		/* R}hCfbNX(0`63, bit7:ACMDtO) */
	DWORD arg		/*  */
)
{
	BYTE n, res;


	if (cmd & 0x80) {	/* ACMD̂Ƃ͐CMD55𑗂 */
		cmd &= 0x7F;
		res = send_cmd(CMD55, 0);
		if (res > 1) return res;
	}

	/* J[h̑I */
	deselect();
	if (!select()) return 0xFF;

	/* R}hpPbg𑗐M */
	xmit_spi(0x40 | cmd);				/* X^[grbg(01) + R}hCfbNX */
	xmit_spi((BYTE)(arg >> 24));		/* [31..24] */
	xmit_spi((BYTE)(arg >> 16));		/* [23..16] */
	xmit_spi((BYTE)(arg >> 8));			/* [15..8] */
	xmit_spi((BYTE)arg);				/* [7..0] */
	n = 0x01;							/* _~[CRC + Stop */
	if (cmd == CMD0) n = 0x95;			/* LCRC (CMD0(0)) */
	if (cmd == CMD8) n = 0x87;			/* LCRC (CMD8(0x1AA)) */
	xmit_spi(n);						/* CRC + Xgbvrbg(1) */

	/* R}hX|X̎M */
	if (cmd == CMD12) rcvr_spi();		/* CMD12̂Ƃ͒1oCgĂ */
	n = 10;								/* LȃX|X҂(ő10oCg) */
	do
		res = rcvr_spi();
	while ((res & 0x80) && --n);

	return res;							/* X|XlԂ */
}



/*--------------------------------------------------------------------------

   pubN֐

---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------*/
/* fBXNu(MMC/SDC)̏                                         */
/*-----------------------------------------------------------------------*/

DSTATUS disk_initialize (
	BYTE drv		/* hCuԍ(0`9) */
)
{
	BYTE n, cmd, ty, ocr[4];

#ifdef USE_CRC16
    MSTP_CRC = 0;
#endif
	if (drv) return STA_NOINIT;			/* {hCoł1̃hCû݃T|[g */
	if (Stat & STA_NODISK) return Stat;	/* \PbgɃJ[h͂邩? */

	power_on();							/* SPI|[g̏ */
	for (n = 10; n; n--) rcvr_spi();	/* CS=Ĥ܂80rbg̃_~[NbN𑗂 */

	ty = 0;
	if (send_cmd(CMD0, 0) == 1) {			/* MMC/SDCSPI[hɈڍs */
		Timer1 = 1000;						/* ^CAEg = 1b */
		if (send_cmd(CMD8, 0x1AA) == 1) {	/* SDv2?(CMD8󂯕t) */
			for (n = 0; n < 4; n++) ocr[n] = rcvr_spi();		/* R7X|X̖߂l𓾂 */
			if (ocr[2] == 0x01 && ocr[3] == 0xAA) {				/* Vcc=2.7-3.6VT|[g邩? */
				while (Timer1 && send_cmd(ACMD41, 1UL << 30))	/* ACMD41(HCS)ŏ҂ */
					;	/* ̃[v͂xԂv. RTOSł͓KXrot_rdq()}. */
				if (Timer1 && send_cmd(CMD58, 0) == 0) {		/* OCRǂݏo */
					for (n = 0; n < 4; n++) ocr[n] = rcvr_spi();
					ty = (ocr[0] & 0x40) ? CT_SD2 | CT_BLOCK : CT_SD2;	/* CCSrbgɏ]AhbVO[h̕ۑ */
				}
			}
		} else {	/* SDv2J[hȊO(SDv1MMCv3) */
			if (send_cmd(ACMD41, 0) <= 1) 	{	/* SDv1 or MMC? */
				ty = CT_SD1; cmd = ACMD41;	/* SDv1pR}h (ACMD41(0)) */
			} else {
				ty = CT_MMC; cmd = CMD1;	/* MMCv3pR}h (CMD1(0)) */
			}
			while (Timer1 && send_cmd(cmd, 0))			/* ҂ */
				;	/* ̃[v͂xԂv. RTOSł͓KXrot_rdq()}. */
			if (!Timer1 || send_cmd(CMD16, 512) != 0)	/* Set block length: 512 */
				ty = 0;
		}
	}
	CardType = ty;	/* Card^Cv̕ۑ */
	deselect();

	if (ty) {			/*  */
		FCLK_FAST();			/* NbNgɐݒ */
		Stat &= ~STA_NOINIT;	/* STA_NOINITtONA() */
	} else {			/* s */
		power_off();			/* J[hdOFF */
		Stat = STA_NOINIT;		/* STA_NOINITtOZbg() */
	}

	return Stat;	/* ݂̃fBXNXe[^XԂ */
}



/*-----------------------------------------------------------------------*/
/* fBXNXe[^X̎擾                                              */
/*-----------------------------------------------------------------------*/

DSTATUS disk_status (
	BYTE drv		/* hCuԍ(0`9) */
)
{
	if (drv) return STA_NOINIT;		/* {hCoł1hCû݃T|[g */

	return Stat;	/* ݂̃fBXNXe[^XԂ */
}


DRESULT disk_sub_read (
	BYTE *buff,		/* f[^obt@ւ̃|C^ */
	DWORD sector,	/* JnZN^ԍ(LBA) */
	BYTE count		/* ǂݏoZN^(1..128) */
)
{
	if (count == 1) {	/* 1ZN^̓ǂݏo */
		if ((send_cmd(CMD17, sector) == 0)	/* 1ZN^ǂݏo(READ_SINGLE_BLOCK) */
			&& rcvr_datablock(buff, 512))
			count = 0;
	}
	else {				/* ZN^̓ǂݏo */
		if (send_cmd(CMD18, sector) == 0) {	/* ZN^ǂݏoJn(READ_MULTIPLE_BLOCK) */
			do {	/* KvȂf[^ubNM */
				if (!rcvr_datablock(buff, 512)) break;
				buff += 512;
			} while (--count);
			send_cmd(CMD12, 0);				/* ǂݏo~(STOP_TRANSMISSION) */
		}
	}
	deselect();

	return count ? RES_ERROR : RES_OK;	/* ʂԂ */
}

/*-----------------------------------------------------------------------*/
/* ZN^̓ǂݏo                                                      */
/*-----------------------------------------------------------------------*/

DRESULT disk_read (
	BYTE drv,		/* hCuԍ(0`9) */
	BYTE *buff,		/* f[^obt@ւ̃|C^ */
	DWORD sector,	/* JnZN^ԍ(LBA) */
	BYTE count		/* ǂݏoZN^(1..128) */
)
{
	int retry;
        DRESULT res;

	if (drv || !count) return RES_PARERR;		/* p[^̃`FbN */
	if (Stat & STA_NOINIT) return RES_NOTRDY;	/* J[h͓\? */

	if (!(CardType & CT_BLOCK)) sector *= 512;	/* J[h̃AhbVO[hŕKvȂAhXϊ */



#ifdef USE_CRC16
        for (retry = 0; retry < 8; retry++) {
	  res = disk_sub_read(buff, sector, count);
          if (res == RES_OK) break;
	  delay_ms(retry * 2);
        }
#else
	res = disk_sub_read(buff, sector, count);
#endif
        return res;
}



/*-----------------------------------------------------------------------*/
/* ZN^̏                                                      */
/*-----------------------------------------------------------------------*/

#if _READONLY == 0
DRESULT disk_write (
	BYTE drv,			/* hCuԍ(0`9) */
	const BYTE *buff,	/* ރf[^ւ̃|C^ */
	DWORD sector,		/* JnZN^ԍ (LBA) */
	BYTE count			/* ރZN^ (1..128) */
)
{
	if (drv || !count) return RES_PARERR;		/* p[^̃`FbN */
	if (Stat & STA_NOINIT) return RES_NOTRDY;	/* J[h͓\? */
	if (Stat & STA_PROTECT) return RES_WRPRT;	/* ݋֎~? */

	if (!(CardType & CT_BLOCK)) sector *= 512;	/* J[h̃AhbVO[hŕKvȂAhXϊ */

	if (count == 1) {	/* 1ZN^̏ */
		if ((send_cmd(CMD24, sector) == 0)	/* 1ZN^(WRITE_BLOCK) */
			&& xmit_datablock(buff, 0xFE))
			count = 0;
	}
	else {				/* ZN^̏ */
		if (CardType & CT_SDC) send_cmd(ACMD23, count);	/* SDC̏ꍇ̓ZN^ɐݒ肷 */
		if (send_cmd(CMD25, sector) == 0) {	/* ZN^݊Jn(WRITE_MULTIPLE_BLOCK) */
			do {	/* KvȂf[^ubN𑗐M */
				if (!xmit_datablock(buff, 0xFC)) break;
				buff += 512;
			} while (--count);
			if (!xmit_datablock(0, 0xFD))	/* ݏI(STOP_TRANg[N) */
				count = 1;
		}
	}
	deselect();

	return count ? RES_ERROR : RES_OK;	/* ʂԂ */
}
#endif /* _READONLY == 0 */



/*-----------------------------------------------------------------------*/
/* f[^]ȊÕhCu                                          */
/*-----------------------------------------------------------------------*/

#if _USE_IOCTL != 0
DRESULT disk_ioctl (
	BYTE drv,		/* hCuԍ (0`9) */
	BYTE ctrl,		/* R}hԍ */
	void *buff		/* f[^ւ̃|C^ */
)
{
	DRESULT res;
	BYTE n, csd[16], *ptr = buff;
	WORD csize;
	DWORD *dp, st, ed;


	if (drv) return RES_PARERR;					/* {hCoł1hCû݃T|[g */
	if (Stat & STA_NOINIT) return RES_NOTRDY;	/* hCu͓\? */

	res = RES_ERROR;

	switch (ctrl) {
	case CTRL_SYNC :		/* hCu̓̊҂ */
		if (select()) {
			deselect();
			res = RES_OK;
		}
		break;

	case GET_SECTOR_COUNT :	/* hCue(ZN^)Ԃ (DOWRD) */
		if ((send_cmd(CMD9, 0) == 0) && rcvr_datablock(csd, 16)) {
			if ((csd[0] >> 6) == 1) {	/* SDC ver 2.00 */
				csize = csd[9] + ((WORD)csd[8] << 8) + 1;
				*(DWORD*)buff = (DWORD)csize << 10;
			} else {					/* SDC ver 1.XX or MMC ver 3 */
				n = (csd[5] & 15) + ((csd[10] & 128) >> 7) + ((csd[9] & 3) << 1) + 2;
				csize = (csd[8] >> 6) + ((WORD)csd[7] << 2) + ((WORD)(csd[6] & 3) << 10) + 1;
				*(DWORD*)buff = (DWORD)csize << (n - 9);
			}
			res = RES_OK;
		}
		break;

	case GET_SECTOR_SIZE :	/* ZN^TCYԂ (WORD)*/
		*(WORD*)buff = 512;	/* SĂMMC/SDC512oCgœ삷 */
		res = RES_OK;
		break;

	case GET_BLOCK_SIZE :	/* ZN^Pʂ̏ubNTCYԂ (DWORD) */
		if (CardType & CT_SD2) {	/* SDC ver 2.00 */
			if (send_cmd(ACMD13, 0) == 0) {	/* Read SD status */
				rcvr_spi();
				if (rcvr_datablock(csd, 16)) {				/* Read partial block */
					for (n = 64 - 16; n; n--) rcvr_spi();	/* Purge trailing data */
					*(DWORD*)buff = 16UL << (csd[10] >> 4);
					res = RES_OK;
				}
			}
		} else {					/* SDC ver 1.XX or MMC */
			if ((send_cmd(CMD9, 0) == 0) && rcvr_datablock(csd, 16)) {	/* Read CSD */
				if (CardType & CT_SD1) {	/* SDC ver 1.XX */
					*(DWORD*)buff = (((csd[10] & 63) << 1) + ((WORD)(csd[11] & 128) >> 7) + 1) << ((csd[13] >> 6) - 1);
				} else {					/* MMC */
					*(DWORD*)buff = ((WORD)((csd[10] & 124) >> 2) + 1) * (((csd[11] & 3) << 3) + ((csd[11] & 224) >> 5) + 1);
				}
				res = RES_OK;
			}
		}
		break;

	case CTRL_ERASE_SECTOR :	/* w肳ꂽ͈͂̃ZN^̏ (_USE_ERASE == 1̂ƂĂ΂) */
		if (!(CardType & CT_SDC)) break;				/* SDC? */
		if (disk_ioctl(drv, MMC_GET_CSD, csd)) break;	/* CSD̓ǂݏo */
		if (!(csd[0] >> 6) && !(csd[10] & 0x40)) break;	/* ZN^Pʂ̃ZN^\ȃJ[h? */
		dp = buff; st = dp[0]; ed = dp[1];				/* ZN^͈̓f[^̏ */
		if (!(CardType & CT_BLOCK)) {
			st *= 512; ed *= 512;
		}
		if (send_cmd(CMD32, st) == 0 && send_cmd(CMD33, ed) == 0 && send_cmd(CMD38, 0) == 0 && wait_ready(30000))	/* ̎s */
			res = RES_OK;	/* FatFs͂̃R}ȟʂ`FbNȂ */
		break;

	/* FatFs͈ȉ̃R}h̓T|[gȂ(sv) */

	case MMC_GET_TYPE :		/* J[h^Cv̎擾 (BYTE) */
		*ptr = CardType;
		res = RES_OK;
		break;

	case MMC_GET_CSD :		/* CSD̓ǂݏo (16 bytes) */
		if (send_cmd(CMD9, 0) == 0		/* READ_CSD */
			&& rcvr_datablock(ptr, 16))
			res = RES_OK;
		break;

	case MMC_GET_CID :		/* CID̓ǂݏo (16 bytes) */
		if (send_cmd(CMD10, 0) == 0		/* READ_CID */
			&& rcvr_datablock(ptr, 16))
			res = RES_OK;
		break;

	case MMC_GET_OCR :		/* OCR̓ǂݏo (4 bytes) */
		if (send_cmd(CMD58, 0) == 0) {	/* READ_OCR */
			for (n = 4; n; n--) *ptr++ = rcvr_spi();
			res = RES_OK;
		}
		break;

	case MMC_GET_SDSTAT :	/* SD status̓ǂݏo (64 bytes) */
		if (send_cmd(ACMD13, 0) == 0) {	/* SD_STATUS */
			rcvr_spi();
			if (rcvr_datablock(ptr, 64))
				res = RES_OK;
		}
		break;

	default:				/* `R}h */
		res = RES_PARERR;
	}

	deselect();

	return res;
}
#endif /* _USE_IOCTL != 0 */


/*-----------------------------------------------------------------------*/
/* ^C}T[rX                                                        */
/*-----------------------------------------------------------------------*/
/* ̊֐, ^C~O̐\Pbg̊Ď̂, ^C}荞
/  1msɌĂяoȂ΂ȂȂ.
*/

void disk_timerproc (void)
{
	WORD n;
	BYTE s;


	n = Timer1;						/* 1kHz decrement timer stopped at 0 */
	if (n) Timer1 = --n;
	n = Timer2;
	if (n) Timer2 = --n;

	s = Stat;
#ifdef USE_WP
	if (WP)		/* Write protected */
		s |= STA_PROTECT;
	else		/* Write enabled */
		s &= ~STA_PROTECT;
#endif
	if (INS)	/* Card is in socket */
		s &= ~STA_NODISK;
	else		/* Socket empty */
		s |= (STA_NODISK | STA_NOINIT);
	Stat = s;
}

static struct s_timer disk_timer;

void add_disk_timer()
{
    disk_timer.tfunc = disk_timerproc;
    add_timer(&disk_timer);
}

