/***********************************************************************/
/*                                                                     */
/*  FILE        :resetprg.c                                            */
/*  DESCRIPTION :Reset Program                                         */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/***********************************************************************/

#include	<machine.h>
#include	<_h_c_lib.h>
#include	"typedefine.h"
#include	"stacksct.h"

void main(void);
extern void HardwareSetup(void);

#define PSW_init  0x00010000
#define FPSW_init 0x00000100

#pragma entry PowerON_Reset_PC

void PowerON_Reset_PC(void)
{ 
	set_intb((unsigned long)__sectop("C$VECT"));
	set_fpsw(FPSW_init);

	HardwareSetup();				// Use Hardware Setup
        nop();

	_INITSCT();

	set_psw(PSW_init);				// Set Ubit & Ibit for PSW


	main();
	while(1);
}
