/*
 * XChV[̏
 */
#include <string.h>
#include "typedefine.h"
#include "iodefine.h"
#include "viewer.h"
#include "dcf.h"

static struct s_timer jpeg_timer;

static void jpeg_timer_increment()
{
    jpeg_timer.counter++;
}

int jpeg_time(int flag)
{
    int val;

    val = jpeg_timer.counter;
    if (flag == 0)
        jpeg_timer.counter = 0;
    return val;
}

void add_jpeg_timer()
{
    jpeg_timer.tfunc = jpeg_timer_increment;
    add_timer(&jpeg_timer);
}

void slide_delay(int n)
{
    delay_ms(n);
}

void copy_line(PIXEL *dst, PIXEL *src, int ypos)
{
    dst += LCD_WIDTH * ypos;
    src += LCD_WIDTH * ypos;
    TransferToGRAM(src, dst, LCD_WIDTH);
}

void copy_cols(PIXEL *dst, PIXEL *src, int xpos)
{
    int y;

    dst += xpos;
    src += xpos;
    while (vb_check() == 0);
    for (y = 0; y < LCD_HEIGHT; y++) {
        *dst = *src;
        dst += LCD_WIDTH;
        src += LCD_WIDTH;
    }
}

void dup_region(PIXEL *dst, PIXEL *src, int xpos, int ypos, int width, int height)
{
    int h;

    dst += LCD_WIDTH * ypos + xpos;
    src += LCD_WIDTH * ypos + xpos;
    for (h = 0; h < height; h++) {
	TransferToGRAM(src, dst, width);
        dst += LCD_WIDTH;
        src += LCD_WIDTH;
    }
}

void copy_region(PIXEL *dst, PIXEL *src, int xpos, int ypos, int width, int height, int dstx, int dsty)
{
    int h;

    dst += LCD_WIDTH * dsty + dstx;
    src += LCD_WIDTH * ypos + xpos;

    for (h = 0; h < height; h++) {
	TransferToGRAM(src, dst, width);
        dst += LCD_WIDTH;
        src += LCD_WIDTH;
    }
}

/*
 * XChV[\Ȃ
 *   cpos: \Jn摜ԍ (0..11)
 */
int slide_show(int cpos)
{
    struct dcf_file_info *pdcf;
    EXIF *exif;
    int nfiles, npos;
    int mode;
    int first_time;
    PIXEL *lower, *upper;
    int width, height;
    int xpos, ypos;
    evinfo *evp;

    lower = (PIXEL *)GRA1_VRAM_BASE;
    upper = (PIXEL *)GRA2_VRAM_BASE;
    /* Clear GRA1 area */
    GRPH_SelectPlane(lower);
    GRPH_Clear(C_BLACK);    /* OtBbNẌNA */

    first_time = 1;
    mode = 0;


    do {
        if (first_time) {
            GCON_locate(15, 7);
            t_printf("...");
            first_time = 0;		
        }

        /*
         * \摜ւ̃|C^
         */
        pdcf = &dcf_files[cpos];
        exif = &pdcf->exif_info;

        /*
         * upper JPEG 摜WJ
         */
        GRPH_SelectPlane(upper);

        if (expand_jpeg(pdcf->pathname, exif)) {
            switch (mode) {
            case 0:
                /*
                 * 㑤牺փRs[
                 */
		        while (vb_check() == 0);
				memcpy(lower, upper, 320*2*240);
                break;
            case 1:
                /* EւƃCvAEg */
                for (xpos = 0; xpos < LCD_WIDTH; xpos++) {
                    copy_cols(lower, upper, xpos);
                    if (xpos & 1) slide_delay(1);
                }
                break;
            case 2:
                /* ォ牺ւƃCvAEg */
                for (ypos = 0; ypos < LCD_HEIGHT; ypos++) {
                    copy_line(lower, upper, ypos);
                    if (ypos & 1) slide_delay(1);
                }
                break;
            case 3:
                /* lO֌ăCvAEg */
                xpos = LCD_WIDTH/2; ypos = LCD_HEIGHT/2;
                width = 0; height = 0;
                do {
                    xpos -= 4; ypos -= 3;
                    width += 8; height += 6;
                    dup_region(lower, upper, xpos, ypos, width, 3);
                    if (height > 6) {
                        dup_region(lower, upper, xpos, ypos+3, 4, height-6);
                        dup_region(lower, upper, xpos+width-4, ypos+3, 4, height-6);
                    }
                    dup_region(lower, upper, xpos, ypos + height -3, width, 3);
                    slide_delay(6);
                } while (width <= LCD_WIDTH);
                break;
            case 4:
                /* ㉺ɌăCvAEg */
                height = 4;
                ypos = LCD_HEIGHT/2;
                do {
                    dup_region(lower, upper, 0, ypos - 2, LCD_WIDTH, 2);
                    dup_region(lower, upper, 0, ypos + height -4, LCD_WIDTH, 2);
                    slide_delay(10);
                    ypos -= 2;
                    height += 4;
                } while (ypos > 0);
                break;
            case 5:
                /* E獶փXChC */
                xpos = LCD_WIDTH - 8;
                for (width = 8; width <= LCD_WIDTH; width += 8) {
                    copy_region(lower, upper, 0, 0, width, LCD_HEIGHT, xpos, 0);
                    xpos -= 8;
                }
                break;
            case 6:
                /* փXChC */
                height = 0;
                for (ypos = LCD_HEIGHT-4; ypos >= 0; ypos -= 4) {
                    height += 4;
                    copy_region(lower, upper, 0, 0, LCD_WIDTH, height, 0, ypos);
                }
                break;
            }
        } else {		
            GCON_SelectPlane(upper);			
            GCON_Initialize();
            GCON_locate(5, 6);
            t_puts(pdcf->pathname);
            GCON_locate(5, 8);
            t_puts("摜傫ĕ\ł܂");			
        }
        mode++;
        mode %= 7;
        jpeg_time(0);

        cpos++;    /* ̉摜ԍ */
        if (cpos == dcf_info.nfiles) {
            /* y[W̏IɒB */
            npos = dcf_info.findex + cpos;
            if (npos == dcf_info.num_files) {
                /* S摜t@C̍ŌɒB̂ŁAŏɖ߂ */
                nfiles = seek_DCF(0);
            } else {
                /* ̃y[Wǂݍ */
                nfiles = seek_DCF(npos);
            }
            cpos = 0;
        }

        /*
         * SLIDE_PERIODԂEGCgB
         * ^b`ꂽAXChV[𒆒fB
         */
        while (jpeg_time(1) < SLIDE_PERIOD) {
            evp = ev_get(0);
            if (evp && evp->ev_type != EV_PENUP) break;
        }
    } while (evp == 0);

    ev_flush();

    return cpos;
}
