/***********************************************************************/
/*                                                                     */
/*  FILE        :hwsetup.c                                             */
/*  DESCRIPTION :Hardware Setup file                                   */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/***********************************************************************/

//`
#include "iodefine.h"
#include "../lcdtext/lcdset.h"
#include "../lcdtext/touch.h"

//vg^Cv錾
extern void HardwareSetup(void);

//֐
//@@@@FȂ
//@^[lFȂ
//@Tv@F
//@@CPG@ @FICLK=96MHz,BCLK=48MHz,PCLK=48MHz
//@@BSC@ @FCS4=16rbg,oCgSRAM,6NbNTCNŒoX
//@@MTU1@@FVSYNCPʂEXDMACN,EXDMACNOɊOoXJp荞ݗv
//@@MTU3@@FHSYNC,DEo,o͂ƂPWM[h1
//@@MTU4@@FDCLKo,PWM[h1
//@@PPG0@@FPO3VSYNCo,MTU3N,m[}[h
//@@EXDMAC0 FCS3(0x04000000)320[h/ubN~240ubN],MTU1v
//@@CMT0@@F^b`opC^[o^C},1ms
//@@CMT1@@FQ[̌oߎԊǗpC^[o^C},10ms
//@@S12AD@ FAN0,AN1^b`ʒuop,1TCNXL[h

void HardwareSetup(void)
{
	SYSTEM.SCKCR.LONG = 0x00010100;	// ICLK=96MHz,BCLK=48MHz,PCLK=48MHz
									//VXeNbNRg[WX^iSCKCRj
									//b11-b8 PCK[3:0]i1j ӃW[NbNIrbg
									//0 0 0 0F~8 <-
									//0 0 0 1F~4
									//0 0 1 0F~2 
									//0 0 1 1F~1
									//b19-b16 BCK[3:0] OoXNbNASDRAMNbNIrbg
									//0 0 0 0F~8
									//0 0 0 1F~4 <-
									//0 0 1 0F~2
									//0 0 1 1F~1
									//b22 PSTOP0 SDCLK[qo͐rbg
									//0FSDCLK[qo͓
									//1FSDCLK[qo͋֎~iHighŒj
									//b23 PSTOP1 BCLK[qo͐rbg
									//0FBCLK[qo͓
									//1FBCLK[qo͒~iHighŒj
									//b27-b24 ICK[3:0]i2j VXeNbNIrbg
									//0 0 0 0F~8
									//0 0 0 1F~4 <-
									//0 0 1 0F~2
									//0 0 1 1F~1

	IOPORT.PF0CSE.BIT.CS4E = 1;
									//|[gt@NVWX^0iPF0CSEj
									//b0 CS0E CS0rbg
									//0FI/O|[gƂĎgp
									//1FCSn#o͒[qin=0`7jƂĎgp
									//b1 CS1E CS1rbgR/W
									//b2 CS2E CS2rbgR/W
									//b3 CS3E CS3rbgR/W
									//b4 CS4E CS4rbgR/W <-
									//b5 CS5E CS5rbgR/W
									//b6 CS6E CS6rbgR/W
									//b7 CS7E CS7rbgR/W

	IOPORT.PF1CSS.BIT.CS4S = 0;
		 							//|[gt@NVWX^1iPF1CSSj
									//b1-b0 CS4S[1:0] CS4#o͒[qIrbg
									//0 0FP64CS4#-Ao <-
									//0 1FP74CS4#-Bo
									//1 xFP24CS4#-Co

	IOPORT.PF3BUS.BYTE = 0x1f;
									//|[gt@NVWX^3iPF3BUSj
									//b0 A16E AhXA16rbg
									//0FA16o͖
									//1FA16o͗L
									//b1 A17E AhXA17rbg
									//b2 A18E AhXA18rbg
									//b3 A19E AhXA19rbg
									//b4 A20E AhXA20rbg
									//b5 A21E AhXA21rbg
									//b6 A22E AhXA22rbg
									//b7 A23E AhXA23rbg

	IOPORT.PF4BUS.BYTE = 0xff;
									//|[gt@NVWX^4iPF4BUSj
									//b1-b0 ADRLE[1:0] AhXA9`A0rbg
									//0 0FA9`A0o͖
									//0 1FA9`A4o͖AA3`A0o͗L
									//1 0FA9`A8o͖AA7`A0o͗L
									//1 1FA9`A0o͗L <-
									//b2 A10E AhXA10rbg
									//0FA10o͖
									//1FA10o͗L <-
									//b3 A11E AhXA11rbg
									//b4 A12E AhXA12rbg
									//b5 A13E AhXA13rbg
									//b6 A14E AhXA14rbg
									//b7 A15E AhXA15rbg

	IOPORT.PF5BUS.BYTE = 0x52;
									//|[gt@NVWX^5iPF5BUSj
									//b1 ADRHMS A23`A16o͑IrbgA23`A16o͑I
									//0FPC[7:0]OAhXoXA23-A`A16-AƂĐݒ <-
									//1FP9[7:0]OAhXoXA23-B`A16-BƂĐݒ
									//b4 DHE f[^D15`D8rbg
									//0FPE7`PE0I/O|[gƂĐݒ
									//1FPE7`PE0Of[^oXD15`D8ƂĐݒ <-
									//b5 DH32E f[^D31`D16rbg
									//0FPG7`PG0AP97`P90I/O|[gƂĐݒ <-
									//1FPG7`PG0AP97`P90Of[^oXD31`D16ƂĐݒ
									//b6 WR1BC1E WR1#/BC1#o͋rbg
									//0FP51I/O|[gƂĐݒ
									//1FP51WR#1܂BC1#ƂĐݒ <-
									//b7 WR32BC32E WR3#/BC3#o͋rbg,WR2#/BC2#o͋rbg
									//0FP56AP57I/O |[gƂĐݒ
									//1FP56WR#2܂BC2#ƂĐݒ,P57WR#3܂BC3#ƂĐݒ <-

	IOPORT.PF6BUS.BYTE = 0x00;
									//|[gt@NVWX^6iPF6BUSj
									//b1-b0 WAITS[1:0] WAITIrbg
									//0 0FP57WAIT#-A͒[qƂĐݒ
									//0 1FP55WAIT#-B͒[qƂĐݒ
									//1 0FPC5WAIT#-C͒[qƂĐݒ
									//1 1FP51WAIT#-D͒[qƂĐݒ
									//b4 MDSDE SDRAM[qrbgb6iDQM1ErbgjQƂĂB
									//b6 DQM1E DQM1rbgMDSDE DQM1E
									//0 xFP70/SDCLKɌASDCLKErbgɂ萧
									//1 0FP67/DQM1ASDRAML
									//1 1FSDRAMLiS[qj
									//b7 SDCLKE SDCLKrbg
									//0FSDCLKo͖
									//1FSDCLKo͗L

	BSC.CS4MOD.WORD = 0x8001;
									//CSn [hWX^iCSnMODjin = 0 ` 7j
									//b0 WRMOD CgANZX[hIrbg
									//0FoCgXg[u[h <-
									//1F1CgXg[u[h
									//b3 EWENB OEFCgrbg
									//0FOEFCg֎~ <-
									//1FOEFCg
									//b8 PRENB y[W[hANZXrbg
									//0Fy[W[hANZX֎~ <-
									//1Fy[W[hANZX
									//b9 PWENB y[WCgANZXrbg
									//0Fy[WCgANZX֎~ <-
									//1Fy[WCgANZX
									//b15 PRMOD y[W[hANZX[hIrbg
									//0Fm[}ANZX݊[h <-
									//1FOf[^[hAAT[g[h
									
	BSC.CS4CR.WORD = 0x0001;
									//CSn 䃌WX^iCSnCRjin = 0 ` 7j
									//b0 EXENB 싖rbg
									//0F֎~
									//1F싖
									//b5-b4 BSIZE[1:0] OoXIrbg
									//0 0F16rbgoXԂɐݒ
									//0 1F32rbgoXԂɐݒ
									//1 0F8rbgoXԂɐݒ
									//1 1Fݒ肵ȂłB
									//b8 EMODE GfBA[hwrbg
									//0FGAñGfBA͓샂[h̃GfBAƓin = 0`7j
									//1FGAñGfBA͓샂[h̃GfBAƈقȂin = 0`7j

	SYSTEM.SYSCR0.WORD = 0x5a03;
									//VXeRg[WX^0iSYSCR0j
									//b0 ROME ROMrbg
									//0FROM
									//1FROML <-
									//b1 EXBE OoXrbg
									//0FOoX
									//1FOoXL <-
									//b15-b8 KEY[7:0] 
									//SYSCR0L[R[h5AhFSYSCR0WX^ւ̏݋

	BSC.CS4WCR1.LONG = 0x04040000;
									//CSn EFCg䃌WX^1iCSnWCR1jin = 0 ` 7j
									//b2-b0 CSPWWAIT[2:0] y[WCgTCNEFCgI
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}
									//b10-b8 CSPRWAIT[2:0] y[W[hTCNEFCgIrbgi2jj
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//	
									//1 1 1FEFCg7TCN}
									//b20-b16 CSWWAIT[4:0] m[}CgTCNEFCgIrbg
									//0 0 0 0 0FEFCg}Ȃ
									//0 0 0 0 1FEFCg1TCN}
									//
									//1 1 1 1 1FEFCg31TCN}
									//b28-b24 CSRWAIT[4:0] m[}[hTCNEFCgIrbg
									//0 0 0 0 0FEFCg}Ȃ
									//0 0 0 0 1FEFCg1TCN}
									//
									//1 1 1 1 1FEFCg31TCN}

	BSC.CS4WCR2.LONG = 0x00110111;
									//CSn EFCg䃌WX^2iCSnWCR2jin = 0 ` 7j
									//b2-b0 CSROFF[2:0] [hCSTCNIrbg
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}
									//b6-b4 CSWOFF[2:0] CgCSTCNIrbg
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}
									//b10-b8 WDOFF[2:0] Cgf[^o͉TCNIrbg
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}
									//b18-b16 RDON[2:0] RDAT[gEFCgIrbg
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}
									//b22-b20 WRON[2:0] WRAT[gEFCgIrbg
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}
									//b26-b24 WDON[2:0] Cgf[^o̓EFCgIrbg
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}
									//b30-b28 CSON[2:0] CSAT[gEFCgIrbg
									//0 0 0FEFCg}Ȃ
									//0 0 1FEFCg1TCN}
									//
									//1 1 1FEFCg7TCN}

	BSC.CS4REC.WORD = 0x0000;
									//CSn JoTCNݒ背WX^iCSnRECjin = 0 ` 7j
									//b3-b0 RRCV[3:0] [hJoݒrbg
									//0 0 0 0FJoTCN}Ȃ
									//0 0 0 1FJoTCN1TCN}
									//
									//1 1 1 1FJoTCN15TCN}
									//b11-b8 WRCV[3:0] CgJoݒrbg
									//0 0 0 0FJoTCN}Ȃ
									//0 0 0 1FJoTCN1TCN}
									//
									//1 1 1 1FJoTCN15TCN}

	//LCD back light ON
	PORT7.DDR.BYTE = 0x01;	
	PORT7.DR.BIT.B0 = 1;
    
	//wakeup hardware
	MSTP(EXDMAC) = 0;	// enable ExDMA 
	MSTP(MTU0) = 0;		// enable MTU2 0-5 
	MSTP(PPG0) = 0;		// enable PPG@VSYNCMp
	MSTP_S12AD = 0;		// enable S12AD@^b`ʒuo
	MSTP_CMT0 = 0;		// enable CMT@^b`p̎荞ݔ
	
	//for start trigger EXDMAC 
	//LCD_DEMɘAEXDMACNA\f[^]
	MTU1.TCR.BYTE = 0x20;					// PCLK CCLR=TGRA
	MTU1.TGRA = LCD_HC * PCLK/LCD_CLK -1;	// RyA}b`EXDMACN
	MTU1.TGRB = LCD_HC * PCLK/LCD_CLK -4;	// RyA}b`Ŋ荞ݏɓOoX~AEXDMAC̋NזȂ
	MTU1.TCNT = (LCD_HC - LCD_HBP + 1) * PCLK/LCD_CLK;	// Y
	ICU.IER[IER_MTU1_TGIB1].BIT.IEN_MTU1_TGIB1 = 1;	// Enable TGIEB 
	ICU.IPR[IPR_MTU1_TGIB1].BYTE = 15;		// Set interrupt priority level
	
	//for display enable and nHSYNC 
	MTU3.TCR.BYTE = 0xa0;					// PCLK CCLR=TGRC
	MTU3.TMDR.BYTE = 0x02;					// PWM1 no-Buffer
	MTU3.TIER.BYTE = 0x01;					// TGIA荞݋
	MTU3.TIORH.BYTE = 0x66;					// mANeBuH
	MTU3.TIORL.BYTE = 0x25;					// ANeBuL
	MTU3.TGRC = LCD_HC * PCLK/LCD_CLK -1;	// HSYNC
	MTU3.TGRD = LCD_HS * PCLK/LCD_CLK -1;	//
	MTU3.TGRA = (LCD_HBP + LCD_HD) * PCLK/LCD_CLK -1;	//DE
	MTU3.TGRB = LCD_HBP * PCLK/LCD_CLK -1;	// 
	IOPORT.PFCMTU.BYTE = 0x04;				// MIOC3C-B[qI
	ICU.IER[IER_MTU3_TGIA3].BIT.IEN_MTU3_TGIA3 = 1;	// Enable TGIEA 
	ICU.IPR[IPR_MTU3_TGIA3].BYTE = 15;		// 荞ݗDx=15

	//for LCD dot clock
	MTU4.TCR.BYTE = 0x20;					// PCLK CCLR=TGRA
	MTU4.TMDR.BYTE = 0x02;					// PWM1
	MTU4.TIORH.BYTE = 0x25;					// LX^[g
	MTU4.TGRA = PCLK/LCD_CLK - 1;			// PCLK/6=8MHz
	MTU4.TGRB = PCLK/LCD_CLK/2 - 1;			// 
  	MTUA.TOER.BYTE = 0x02; 					// MTIOC4A[qL 
	
	//for VSYNC
	PPG0.NDERL.BYTE = 0x08;					// PO3gp
	PPG0.PODRL.BYTE = 0x08;					// Ho
	PPG0.NDRL.BYTE = 0x08;					// 
	PPG0.PCR.BYTE = 0xff;					// m[}[hAMTU3gK
		

	EXDMAC0.EDMSAR = (void *)0x04000000;	// \JnCS4̈̐擪
	EXDMAC0.EDMDAR = (void *)0x07000000;	// OԂȂǂłOK(VOAhX)
	EXDMAC0.EDMCRA = (LCD_HD <<16) + LCD_HD;	// 320hbgPubNƂ
	EXDMAC0.EDMCRB = LCD_VD;				// 240ubN̓]
	EXDMAC0.EDMTMD.WORD = 0x8103;			// ubN][hAMTU1v
#ifdef notdef
	EXDMAC0.EDMAMD.LONG = 0x00028000;		// VOAhXA]̓CNgA]͌Œ
#else
	EXDMAC0.EDMAMD.LONG = 0x00029200;		// VOAhXA]̓CNgA]͌Œ
	EXDMAC0.EDMOFR = 256;
#endif
	EXDMAC0.EDMCNT.BYTE = 1;				// `l0Cl[u
	EXDMAC.EDMAST.BYTE = 1;					// }X^Cl[u
	
	MTUA.TSTR.BYTE = 0xc2;					// Strat MTU1,3,4

	//for touch
	S12AD.ADCSR.BYTE = 0x10;				//	ADIE=1,1cycle scan

	CMT0.CMCR.WORD = 0x0040;				// 1/8
	CMT0.CMCOR = PCLK*1000000L/8/1000 -1;	// 1000Hz(1ms)
	ICU.IER[IER_CMT0_CMI0].BIT.IEN_CMT0_CMI0 = 1;	// Enable CMIE 
	ICU.IPR[IPR_CMT0_CMI0].BYTE = 10;		// Set interrupt priority level
	CMT.CMSTR0.WORD = 1;					// start

	PORTC.DR.BYTE = T_idle_DR;
	PORTC.DDR.BYTE = T_idle_DDR;

	//for tact switches
	CMT1.CMCR.WORD = 0x0040;				// 1/8
	CMT1.CMCOR = PCLK*1000000L/8/100 -1;	// 100Hz(10ms)
	ICU.IER[IER_CMT1_CMI1].BIT.IEN_CMT1_CMI1 = 1;	//Enable CMIE 
	ICU.IPR[IPR_CMT1_CMI1].BYTE = 9;		// Set interrupt priority level
	
	// Push switches
	PORT4.DDR.BIT.B4 = 0;	// P44: SW_RIGHT
	PORT4.DDR.BIT.B5 = 0;	// P45: SW_LEFT
	PORT4.DDR.BIT.B6 = 0;	// P46: SW_DOWN
	PORT4.DDR.BIT.B7 = 0;	// P47: SW_UP

	PORT6.DDR.BIT.B6 = 0;	// P66: SW_A
	PORT6.DDR.BIT.B7 = 0;	// P66: SW_B
}


