/*
 *  {\fvO
 *
 */
#include "../lcdtext/event.h"
#include "../lcdtext/graphics.h"
#include "../lcdtext/grphcon.h"

#define	K_COLS	16
#define	K_ROWS	12

#define	B1P1START 0x81
#define	B1P1END	  0x9f
#define	B1P2START 0xE0
#define	B1P2END	  0xEF
#define	B2START	  0x40
#define	B2END     0xFC

/*
 * R[h\̕\
 */
void table_viewer()
{
    int xpos, ypos, b1, b2;
    int i, j;
    int quit;
    evinfo *evp;

    xpos = B2START;
    ypos = B1P1START;
    quit = 0;

    do {
	GCON_clear();
	GCON_locate(3, 0);
	for (i = 0; i < K_COLS; i++) {
	    b2 = xpos + i;
	    if (b2 > B2END)
		break;
	    t_printf("%2x", xpos + i);
	}
	t_puts("\n");

	b1 = ypos;
	for (i = 0; i < K_ROWS; i++) {
	    if (b1 == B1P1END + 1) {
		b1 = B1P2START;
	    }
	    if (b1 > B1P2END)
		break;

	    t_printf("%2x ", b1);
	    b2 = xpos;
	    for (j = 0; j < K_COLS; j++) {
		t_putch((b1 << 8) | b2);
		b2++;
		if (b2 > B2END)
		    break;
	    }
	    t_puts("\n");
	    b1++;
	}
	evp = ev_get(1);
	switch (evp->ev_type) {
	case EV_RIGHT_KEY:
	    if (xpos <= B2END - K_COLS)
	        xpos += K_COLS;
	    break;
	case EV_LEFT_KEY:
	    if (xpos >= B2START + K_COLS)
		xpos -= K_COLS;
	    break;
	case EV_UP_KEY:
	    if (ypos >= B1P1START + K_ROWS) {
		ypos -= K_ROWS;
		if (ypos < B1P2START && ypos > B1P1END) {
		    i = B1P2START - ypos;
		    ypos = B1P1END - i + 1;
		}
	    }
	    break;
	case EV_DOWN_KEY:
	    if (ypos <= B1P2END - K_ROWS) {
		ypos = b1;
	    }
	    break;
	case EV_SEL_RIGHT:
	case EV_SEL_LEFT:
	    quit = 1;
	    break;
	}
    } while (!quit);
}

struct s_colors {
  char *name;
  char *kname;
  unsigned short color_val;
};

struct s_colors colors[17] = {
 { "RED",    "ԐF",   C_RED },      { "YELLOW", "F", C_YELLOW },
 { "LIME",   "C", C_LIME },     { "AQUA", "ANA",   C_AQUA },
 { "BLUE",   "F",   C_BLUE },     { "FUCHSIA", "tNVA", C_FUCHSIA },
 { "MAROON", "IF",   C_MAROON },   { "OLIVE",  "I[u", C_OLIVE },
 { "GREEN",  "ΐF",   C_GREEN  },   { "TEAL",   "eB[", C_TEAL },
 { "NAVY",   "F",   C_NAVY   },   { "PURPLE", "F", C_PURPLE },
 { "BLACK",  "F",   C_BLACK  },   { "GRAY",   "DF", C_GRAY },
 { "SILVER", "F",   C_SILVER },   { "WHITE",  "F", C_WHITE },
};

void text_demo()
{
    int i, code, b1, b2;
    struct s_colors *pcolor;
    char buffer[40];

    GCON_clear();
    GCON_locate(0,0);

    /* p̃_v */
    for (code = 0; code < 0x100; code++) {
	GCON_putc(code);
    }
    ev_get(1);
    /* Sp̃_v */
    for (b1 = 0x81; b1 < 0xa0; b1++) {
	for (b2 = 0x40; b2 < 0xfd; b2++) {
	    code = (b1 << 8) | b2;
	    GCON_putc(code);
	}
    }
    for (b1 = 0xe0; b1 < 0xeb; b1++) {
	for (b2 = 0x40; b2 < 0xfd; b2++) {
	    code = (b1 << 8) | b2;
	    GCON_putc(code);
	}
    }
    ev_get(1);

    GCON_clear();
    GCON_locate(0,0);
    /* OiFςȂ̕\ */
    pcolor = colors;
    for (i = 0; i < 16; i++) {
	t_sprintf(buffer, " %s (%s) ", pcolor->name, pcolor->kname);
	if (pcolor->color_val == C_BLACK) {
	    GCON_set_color((pcolor->color_val), C_WHITE);
	} else {
	    GCON_set_color((pcolor->color_val), C_BLACK);
	}
	GCON_putstr(buffer);
	pcolor++;
    }
    /* wiFςȂ̕\ */
    pcolor = colors;
    for (i = 0; i < 16; i++) {
	t_sprintf(buffer, " %s (%s) ", pcolor->name, pcolor->kname);
	if (pcolor->color_val == C_BLACK) {
	    GCON_set_color(C_WHITE, (pcolor->color_val));
	} else {
	    GCON_set_color(C_BLACK, pcolor->color_val);
	}
	GCON_putstr(buffer);
	pcolor++;
    }

    ev_get(1);
    GCON_set_color(C_WHITE, C_BLACK);
    GCON_clear();
}
