#ifndef __EVENT_H__
#define	__EVENT_H__

#define	EV_LEFTKEY_UP	 1
#define	EV_LEFTKEY_DOWN	 2
#define	EV_RIGHTKEY_UP	 3
#define	EV_RIGHTKEY_DOWN 4
#define	EV_DOWNKEY_UP	 5
#define	EV_DOWNKEY_DOWN	 6
#define	EV_UPKEY_UP	 7
#define	EV_UPKEY_DOWN	 8
#define	EV_ASELKEY_UP	 9
#define	EV_ASELKEY_DOWN	10
#define	EV_BSELKEY_UP	11
#define	EV_BSELKEY_DOWN	12
#define	EV_PENUP	13
#define	EV_PENDOWN	14

#define	EV_UP_KEY	EV_UPKEY_DOWN
#define	EV_DOWN_KEY	EV_DOWNKEY_DOWN
#define	EV_LEFT_KEY	EV_LEFTKEY_DOWN
#define	EV_RIGHT_KEY	EV_RIGHTKEY_DOWN
#define	EV_SEL_RIGHT	EV_ASELKEY_DOWN
#define	EV_SEL_LEFT	EV_BSELKEY_DOWN

#define	EV_SCROLL_UP	20
#define	EV_SCROLL_DOWN	21
#define	EV_NOP		22
#define	EV_PIC0		0x080
#define	EV_SCLICK	0x100
#define	EV_DCLICK	0x200

typedef struct {
    int ev_type;
    int ev_time;
    short xpos, ypos;
} evinfo;

extern volatile evinfo *ev_top;
extern volatile evinfo *ev_tail;

extern void ev_add(int event, int xpos, int ypos);
extern evinfo *ev_get(int do_wait);
extern void ev_init();
extern void ev_flush();
extern void ev_wait(int wevent);
#endif
