/************************************************************************/
/* {OtBbNX`惋[`                                       */
/************************************************************************/

/* {OtBbNX`惋[`wb_ */
#include "graphics.h"

PIXEL *GRPH_Buffer;		/* t[obt@x[XAhX */

/* OtBbNX */
void GRPH_Initialize(void)
{
	/* Setup Initial frame buffer address (GRA1) */
	GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
}


/***** ჌xOtBbNX`֐ *****/


/* ʃNA */
void GRPH_Clear(PIXEL c)
{
	int i;
	PIXEL *p;

	p=(PIXEL *)GRPH_Buffer;
#ifdef VB_CHECK
	if (c == 0) {
	    while (vb_check() == 0) ;
	    memset(p, 0, GRPH_width * GRPH_height * sizeof(PIXEL));
	    return;
	}
#endif
	for(i=0;i<GRPH_width*GRPH_height;i++){
		*p++=c;
	}
}

void GRPH_Copy(PIXEL *p1, PIXEL *p2)
{
	int i;

	for (i = 0; i < GRPH_width * GRPH_height; i++)
		*p1++ = *p2++;
}


/* _` */
void GRPH_Pset(int x, int y, PIXEL c)
{
	PIXEL *p;

	if ((x >= GRPH_clip_window_sx) && (y >= GRPH_clip_window_sy) &&
	    (x <= GRPH_clip_window_ex) && (y <= GRPH_clip_window_ey))
	{
		p=(PIXEL *)(GRPH_Buffer) + x + y * GRPH_width;
		*p = c;
	}
}


#ifdef notdef
int abs(int i)
{
	return i<0 ? -i : i;
}

int sign(int i)
{
	return i<0 ? -1 : 1;
}
#endif

int ClipLine(int sx, int sy, int ex, int ey, 
			  int *clippedSx, 
			  int *clippedSy, 
			  int *clippedEx, 
			  int *clippedEy)
{
	int	tempVal;

/* Yւ̕`ɐK */

	if (sy > ey)
	{
		*clippedSx = ex;
		*clippedSy = ey;
		*clippedEx = sx;
		*clippedEy = sy;
	}
	else
	{
		*clippedSx = sx;
		*clippedSy = sy;
		*clippedEx = ex;
		*clippedEy = ey;
	}
	if (*clippedEy < GRPH_clip_window_sy) return 0;	/* SĉʊO */
	if (*clippedSy > GRPH_clip_window_ey) return 0;	/* SĉʊO */

/* clippedSy`͈͊O(<GRPH_clip_window_sy)̏ꍇA
   (0,GRPH_clip_window_sy)YƂ̌_A
   V(ClippedSx,ClippedSy)Ƃ*/

	if (*clippedSy < GRPH_clip_window_sy)
	{
		if (sy != ey)
		{
			*clippedSx = (sx-ex)*(GRPH_clip_window_sy-sy)/(sy-ey)+sx;
		}
		else
		{
			/* sy = ey ̏ꍇADevide by 0ɂȂ̂ł̑΍ */
			*clippedSx = ((sx-ex)*(GRPH_clip_window_sy-sy)>=0 ? 32767 : -32768);
		}
		*clippedSy = GRPH_clip_window_sy;
	}

/* clippedEy`͈͊O(>GRPH_clip_window_ey)̏ꍇA
   (0,GRPH_clip_window_ey)YƂ̌_A
   V(ClippedEx,ClippedEy)Ƃ*/

	if (*clippedEy > GRPH_clip_window_ey)
	{
		if (sy != ey)
		{
			*clippedEx = (sx-ex)*(GRPH_clip_window_ey-sy)/(sy-ey)+sx;
		}
		else
		{
			/* sy = ey̏ꍇADevide by 0ɂȂ̂ł̑΍ */
			*clippedEx = ((sx-ex)*(GRPH_clip_window_sy-sy)>=0 ? 32767 : -32768);
		}
		*clippedEy = GRPH_clip_window_ey;
	}

/* Xւ̕`ɐK */
	if (*clippedSx > *clippedEx)
	{
		tempVal = *clippedSx;
		*clippedSx = *clippedEx;
		*clippedEx = tempVal;

		tempVal = *clippedSy;
		*clippedSy = *clippedEy;
		*clippedEy = tempVal;
	}

	if (*clippedEx < GRPH_clip_window_sx) return 0;	/* SĉʊO */
	if (*clippedSx > GRPH_clip_window_ex) return 0;	/* SĉʊO */

/* clippedSx`͈͊O(<GRPH_clip_window_sx)̏ꍇA
   (GRPH_clip_window_sx,0)XƂ̌_A
   V(ClippedSx,ClippedSy)Ƃ */

	if (*clippedSx < GRPH_clip_window_sx)
	{
		if (sx != ex)
		{
			*clippedSy = (sy-ey)*(GRPH_clip_window_sx-sx)/(sx-ex)+sy;
		}
		else
		{
			/* sx = ex̏ꍇADevide by 0ɂȂ̂ł̑΍ */
			*clippedSy = ((sy-ey)*(GRPH_clip_window_sx-sx)>=0 ? 32767 : -32768);
		}
		*clippedSx = GRPH_clip_window_sx;
	}

/* clippedEx`͈͊O(>=GRPH_clip_window_ex)̏ꍇA
   (GRPH_clip_window_ex, 0)XƂ̌_
   V(ClippedSx,ClippedSy)Ƃ*/

	if (*clippedEx > GRPH_clip_window_ex)
	{
		if (sx != ex)
		{
			*clippedEy = (sy-ey)*(GRPH_clip_window_ex-sx)/(sx-ex)+sy;
		}
		else
		{
			/* sx = ex̏ꍇADevide by 0ɂȂ̂ł̑΍ */
			*clippedEy = ((sy-ey)*(GRPH_clip_window_ex-sx)>=0 ? 32767 : -32768);
		}
		*clippedEx = GRPH_clip_window_ex;
	}

	if (*clippedSy < *clippedEy)
	{
		if (*clippedEy < GRPH_clip_window_sy) return 0;
	}
	else
	{
		if (*clippedSy > GRPH_clip_window_ey) return 0;
	}

	return 1;

}

void _HorizontalLine(int sx, int sy, int width, PIXEL c)
{
	PIXEL	*p;

	p=(PIXEL *)(GRPH_Buffer) + sx + sy * GRPH_width;
	for (;width>0;width--)
	{
		*(p++) = c;
	}
}

void _VerticalLine(int sx, int sy, int height, PIXEL c)
{
	PIXEL	*p;

	p=(PIXEL *)(GRPH_Buffer) + sx + sy * GRPH_width;
	for (;height>0;height--)
	{
		*p = c;
		p += GRPH_width;
	}
}


void HorizontalLine(int sx, int sy, int ex, PIXEL c)
{

	int clippedSx, clippedEx;

	if (sy < GRPH_clip_window_sy) return;
	if (sy > GRPH_clip_window_ey) return;
	if (sx > ex)
	{
		clippedSx = ex;
		clippedEx = sx;
	}
	else
	{
		clippedSx = sx;
		clippedEx = ex;
	}
	if (clippedEx < GRPH_clip_window_sx) return;
	if (clippedSx > GRPH_clip_window_ex) return;

	if (clippedSx < GRPH_clip_window_sx) clippedSx = GRPH_clip_window_sx;
	if (clippedEx > GRPH_clip_window_ex) clippedEx = GRPH_clip_window_ex;

	_HorizontalLine(clippedSx, sy, clippedEx - clippedSx + 1, c);
}

void VerticalLine(int sx, int sy, int ey, PIXEL c)
{

	int clippedSy, clippedEy;

	if (sx < GRPH_clip_window_sx) return;
	if (sx > GRPH_clip_window_ex) return;
	if (sy > ey)
	{
		clippedSy = ey;
		clippedEy = sy;
	}
	else
	{
		clippedSy = sy;
		clippedEy = ey;
	}
	if (clippedEy < GRPH_clip_window_sy) return;
	if (clippedSy > GRPH_clip_window_ey) return;

	if (clippedSy < GRPH_clip_window_sy) clippedSy = GRPH_clip_window_sy;
	if (clippedEy > GRPH_clip_window_ey) clippedEy = GRPH_clip_window_ey;

	_VerticalLine(sx, clippedSy, clippedEy - clippedSy + 1, c);
}


/* C` */
void GRPH_Line(int sx, int sy, int ex, int ey, PIXEL c)
{
	int clippedSx, clippedSy, clippedEx, clippedEy;
	unsigned int remainX , remainY;
	unsigned int remainderMax , remainderMin, remainder;
	unsigned int remainingPixels;
	int	dX, dY;
	int	dXY1, dXY2;
	PIXEL	*p;

/* `͈͕݂̐̂ɂ*/

	if (ClipLine(sx, sy, ex, ey, &clippedSx, &clippedSy, &clippedEx, &clippedEy)==0) return;

/* ̏ꍇ */
	if (clippedSy == clippedEy)
	{
		HorizontalLine(clippedSx, clippedSy, clippedEx, c);
		return;
	}

/* ̏ꍇ */
	if (clippedSx == clippedEx)
	{
		VerticalLine(clippedSx, clippedSy, clippedEy, c);
		return;
	}


/* `̌Ə */

	/* X */
	if (clippedSx > clippedEx)
	{
		dX = -1;
		remainX = clippedSx - clippedEx;
	}
	else
	{
		dX = 1;
		remainX = clippedEx - clippedSx;
	}

	/* Y */
	if (clippedSy > clippedEy)
	{
		dY = -GRPH_width;
		remainY = clippedSy - clippedEy;
	}
	else
	{
		dY = GRPH_width;
		remainY = clippedEy - clippedSy;
	}

	/* ̌X45xɁAXŶǂx[Xɕ`悷邩 */
	if (remainX > remainY)
	{
		remainderMax = remainX;
		remainderMin = remainY;
		remainingPixels = remainX;
		dXY1 = dX;
		dXY2 = dY;
	}
	else
	{
		remainderMax = remainY;
		remainderMin = remainX;
		remainingPixels = remainY;
		dXY1 = dY;
		dXY2 = dX;
	}

	/* +0.5āAsNZ̒SŌvZ*/
	remainder = remainderMax >> 1;

	/* C` */
	p=((PIXEL *)(GRPH_Buffer)) + clippedSx + clippedSy * GRPH_width;

	for (;;)
	{
		*p=c;
		if (remainingPixels == 0) break;
		remainingPixels--;
		p += dXY1;
		if (remainder < remainderMin)
		{
			remainder += remainderMax;
			p += dXY2;
		}
		remainder -= remainderMin;
	}
}


/* {bNX`(f1Ȃ{bNXtB) */
void GRPH_Box(int sx, int sy, int ex, int ey, PIXEL c, int f)
{

	int leftX, topY;
	int rightX, bottomY;
	int y;

/* eR[i[̈ʒu */

	if (sx > ex)
	{
		leftX = ex;
		rightX = sx;
	}
	else
	{
		leftX = sx;
		rightX = ex;
	}

	if (sy > ey)
	{
		topY = ey;
		bottomY = sy;
	}
	else
	{
		topY = sy;
		bottomY = ey;
	}

	if (f)
	{
		for (y = topY ; y <= bottomY; y++)
		{
			HorizontalLine(leftX, y, rightX, c);
		}
	}
	else
	{
		HorizontalLine(leftX, topY, rightX, c);
		for (y = topY+1; y < bottomY; y++)
		{
			GRPH_Pset(leftX, y, c);
			GRPH_Pset(rightX, y, c);
		}
		HorizontalLine(leftX, bottomY, rightX, c);
	}
}


/* T[N`(f1ȂT[NtB) */
void GRPH_Circle(int x, int y, int rh, int rv, PIXEL c, int f)
{
	int	dx, dy, dr, dr1, dr2, dr3;
	int	absDR1, absDR2, absDR3;

	int	rv2, rh2;

	if (rv == rh)
	{
	/* ^~̕` */
	/*
		WvŹA(0, R)(R, 0)܂Ŗ{̔aRƂ̌덷ŏ̕ɐi
		AA~̑Ώ̂𗘗p45x̉~ʂ̍WvẐ݂ŕ`悷

		݂̍W(X,Y)A̍Wւ̍(dx,dy), {̔aRƂ

		݂̍W̔ǎ덷E͈ȉŕ\
			E = X^2 + Y^2 - R^2

		̍W̌덷Enext́AȉɂȂ
			Enext = (X+dx)^2 + (Y+dy) -R^2
				  = X^2 + 2Xdx+ dx^2 + Y^2 + 2Ydy + dy^2 - R^2
				  = E + 2Xdx + 2Ydy + dx^2 + dy^2
		A̐iމ\̂O̌̍W̔ǎ덷߂
			E(x+1, y  ) = E + 2x + 1
			E(x  , y-1) = E - 2y + 1
			E(x+1, y-1) = E + 2x - 2y + 2
		̎O̌덷Βlňԏ̂̍WƂB
	*/

		dx = 0;
		dy = rv;
		dr = 0;
		for(;;)
		{
			/*~̑Ώ̐𗘗p̍W8̓_̍W߂*/
			if (f)
			{

				HorizontalLine(x + dx, y + dy, x - dx, c);
				HorizontalLine(x + dx, y - dy, x - dx, c);
				HorizontalLine(x + dy, y + dx, x - dy, c);
				HorizontalLine(x + dy, y - dx, x - dy, c);
			}
			else
			{
				GRPH_Pset(x + dx, y + dy, c);
				GRPH_Pset(x + dx, y - dy, c);
				GRPH_Pset(x - dx, y + dy, c);
				GRPH_Pset(x - dx, y - dy, c);

				GRPH_Pset(x + dy, y + dx, c);
				GRPH_Pset(x + dy, y - dx, c);
				GRPH_Pset(x - dy, y + dx, c);
				GRPH_Pset(x - dy, y - dx, c);
			}

			/*~81(45x)`悵I*/
			if (dx >= dy) break;

			absDR1 = dr1 = dr + 2*dx + 1;
			absDR2 = dr2 = dr - 2*dy + 1;
			absDR3 = dr3 = dr + 2*dx - 2*dy + 2;

			if (absDR1 < 0) absDR1 = - absDR1;
			if (absDR2 < 0) absDR2 = - absDR2;
			if (absDR3 < 0) absDR3 = - absDR3;

			if (absDR1 < absDR2)
			{
				if (absDR1 < absDR3)
				{
					++dx;
					dr = dr1;
				}
				else
				{
					++dx;
					--dy;
					dr = dr3;
				}
			}
			else
			{
				if (absDR2 < absDR3)
				{
					--dy;
					dr = dr2;
				}
				else
				{
					++dx;
					--dy;
					dr = dr3;
				}
			}
		}
	}
	else
	{
	/* ȉ~̕` */
	/*
		WvŹA(0, rv)(rh, 0)܂Ŗ{̔aRƂ̌덷ŏ̕ɐi
		AAȉ~Ώ̂𗘗p90x̉~ʂ̍WvẐ݂ŕ`悷

		݂̍W(X,Y)A̍Wւ̍(dx,dy), {̔aRƂ

		ȉ~̎
			x^2/rh^2 + y^2/rv^2 = 1
		A݂̍W̔ǎ덷Et͈ȉŕ\
			Et = X^2/rh^2 + Y^2/rv^2 - 1
			Et*rh^2*rv^2 = rv^2*x^2+rh^2*y^2-rh^2*rv^2
		AArvrh͌ŒlȂ̂ŁAWƂĂ܂Ƃߌ덷EƂvZ₷A
		덷̎́A
			E = rv^2*x^2+rh^2*y^2-rh^2*rv^2
		ƂȂB
		̍W̌덷Enext́AȉɂȂ
			Enext = rv^2*(X+dx)^2 + rh^2*(Y+dy) -rh^2*rv^2
				  =   rv^2*X^2 + rv^2*2Xdx + rv^2*dx^2
				    + rh^2*Y^2 + rh^2*2Ydy + rh^2*dy^2
				    - rh^2*rv^2
				  = E + rv^2(2Xdx+dx^2) + rh^2(2Ydy+dy^2)
		A̐iމ\̂O̌̍W̔ǎ덷߂
			E(x+1, y  ) = E + rv^2(2X+1)
			E(x  , y-1) = E - rh^2(2Y-1)
			E(x+1, y-1) = E + rv^2(2X+1) - rh^2(2Y-1)
		̎O̌덷Βlňԏ̂̍WƂB
	*/

		rv2 = rv * rv;
		rh2 = rh * rh;
		dx = 0;
		dy = rv;
		dr = 0;
		for(;;)
		{
			/*ȉ~̑Ώ̐𗘗p̍W4̓_̍W߂*/
			if (f)
			{
				HorizontalLine(x + dx, y + dy, x - dx, c);
				HorizontalLine(x + dx, y - dy, x - dx, c);
			}
			else
			{
				GRPH_Pset(x + dx, y + dy, c);
				GRPH_Pset(x + dx, y - dy, c);
				GRPH_Pset(x - dx, y + dy, c);
				GRPH_Pset(x - dx, y - dy, c);
			}

			if ((dx == rh) && (dy == 0)) break;

			absDR1 = dr1 = dr + 2*dx*rv2 + rv2;
			absDR2 = dr2 = dr - 2*dy*rh2 + rh2;
			absDR3 = dr3 = dr + 2*dx*rv2 + rv2 - 2*dy*rh2 + rh2;

			if (absDR1 < 0) absDR1 = - absDR1;
			if (absDR2 < 0) absDR2 = - absDR2;
			if (absDR3 < 0) absDR3 = - absDR3;

			if (absDR1 < absDR2)
			{
				if (absDR1 < absDR3)
				{
					++dx;
					dr = dr1;
				}
				else
				{
					++dx;
					--dy;
					dr = dr3;
				}
			}
			else
			{
				if (absDR2 < absDR3)
				{
					--dy;
					dr = dr2;
				}
				else
				{
					++dx;
					--dy;
					dr = dr3;
				}
			}
		}
	}
}

/* yCg` */

/* Pain sub (ċAIɌĂ΂) */
void PaintALine(int x, int y, PIXEL c, PIXEL bc)
{
	PIXEL	*leftscanp, *rightscanp;
	int		sx, ex;

	/* EɎwFScan */
	leftscanp = rightscanp = (PIXEL *)(GRPH_Buffer) + x + y * GRPH_width;
	
	/* wʒu(x,y)́AbcƓFOȂ̂ŁA
	   ̃̕`FbN͏ȂA(x-1, y)(x+1,y)scanB
	*/
	leftscanp--;
	for (sx = x-1; sx >= GRPH_clip_window_sx ; sx--)
	{
		if (*leftscanp != bc) break;
		leftscanp--;
	}
	leftscanp++;
	sx++;

	rightscanp++;
	for (ex = x+1; ex <= GRPH_clip_window_ex; ex++)
	{
		if (*rightscanp != bc) break;
		rightscanp++;
	}
	ex--;

	/* ScanʂɁAwF̕hԂ */
	HorizontalLine(sx, y, ex, c);

	/* 㕔C(sx, y-1) to (ex, y-1)
	   C(sx, y+1) to (ex, y+1)̎wFTA
	   N_ƂčĂуyCgJn*/
	for (; sx <= ex ; sx++)
	{
		if (y > GRPH_clip_window_sy)
		{
			if (*(leftscanp-GRPH_width) == bc) PaintALine(sx, y-1, c, bc);
		}
		if (y < GRPH_clip_window_ey)
		{
			if (*(leftscanp+GRPH_width) == bc) PaintALine(sx, y+1, c, bc);
		}
		leftscanp++;
	}
}

/* Paint Main */
void GRPH_Paint(int x, int y, PIXEL c)
{
	PIXEL	backcolor;

	if ((x < GRPH_clip_window_sx) ||
	    (x > GRPH_clip_window_ex) ||
	    (y < GRPH_clip_window_sy) ||
	    (y > GRPH_clip_window_ey)) return;
	backcolor = *((PIXEL *)(GRPH_Buffer) + x + y * GRPH_width);
	PaintALine(x, y, c, backcolor);
	return;
}
