/*******************************************************************************
	OtBbNXʃR\[`惉Cu
	(IWiInterface2002N3Wx SERIKAR\[Cu)
*******************************************************************************/
#include <stdarg.h>
#include <stdio.h>
#include	"font.h"
#include	"graphics.h"
#include	"grphcon.h"

#include "fontdata.c"

/* sNZ` */
typedef unsigned short GCON_PIXEL;

/* t[obt@̂wsNZ */
#define FRAME_WIDTH		LCD_WIDTH

/* R\[dl` */
#define	con_bx   0		/* R\[wn_ */
#define	con_by   0		/* R\[xn_ */
#define	tab_cols 8		/* TAB */

struct scinfo screen_info;

#define GCON_TOP  ((GCON_PIXEL *)GRA1_VRAM_BASE)
#define	GCON_PIXSIZE	(1024*256/2)
#define GCON_WRAP ((GCON_PIXEL *)GRA2_VRAM_BASE)

static GCON_PIXEL		*GCON_gram = GCON_TOP;	/* GRAM\擪AhX */

#define	WRAP_ADDR(pixaddr)	if (pixaddr >= GCON_WRAP) pixaddr -= GCON_PIXSIZE;

static GCON_PIXEL		col_fg;					/* OiF */
static GCON_PIXEL		col_bg;					/* wiF */
static GCON_PIXEL		col_curxor;				/* J[\]F */

static int			cur_on;				/* J[\\E\ */
static int			cur_x;				/* J[\ʒu */
static int			cur_y;				/* J[\sʒu */

#define	MAX_GWIDTH	16
#define	MAX_GHEIGHT	16

static GCON_PIXEL		line_pm[FRAME_WIDTH];	/* ƃobt@ */

int GCON_gram_addr()
{
    return (int)GCON_gram;
}

/*******************************************************************************
	R\[
*******************************************************************************/
int GCON_init_blt( PIXEL *gram, unsigned char *font )
{
    GCON_gram	= (GCON_PIXEL *)gram;
    sc_col_width = finfo_ascii.gwidth;
    sc_row_height = finfo_ascii.gheight;
    sc_cols = GRPH_width / sc_col_width;
    sc_rows = GRPH_height / sc_row_height;

    return(0);
}

/*******************************************************************************
	CPU  t[ `]
*******************************************************************************/
void GCON_con_cpu2gram( int x, int y, int nx, int ny, GCON_PIXEL *pm )
{
    GCON_PIXEL	*src, *s;
    GCON_PIXEL	*dst, *d;
    int            i, l;

    x += con_bx;
    y += con_by;

    src = pm;
    dst = GCON_gram + (y * FRAME_WIDTH + x);
    WRAP_ADDR(dst);

    for( i = 0; i < ny; i++ ){
        s = src;
        d = dst;
        if (dst + nx >= GCON_WRAP) {
          for(l = 0; l < nx; l++ ){
            WRAP_ADDR(d);
            *d++ = *s++;
          }
        } else {
          for(l = 0; l < nx; l++ ){
            *d++ = *s++;
          }
        }
        src += nx;
        dst += FRAME_WIDTH;
    }
    return;
}

/*******************************************************************************
	t[  CPU `]
*******************************************************************************/
void GCON_con_gram2cpu( int x, int y, int nx, int ny, GCON_PIXEL *pm )
{
GCON_PIXEL	*src, *s;
GCON_PIXEL	*dst, *d;
int			i, l;

	x += con_bx;
	y += con_by;

	src = GCON_gram + (y * FRAME_WIDTH + x);
	dst = pm;
	for( i = 0; i < ny; i++ ){
		s = src;
		d = dst;
		for(l = 0; l < nx; l++ ){
        WRAP_ADDR(src);
			*d++ = *s++;
		}
		src += FRAME_WIDTH;
		dst += nx;
	}
	return;
}

/*******************************************************************************
	t[ `]
*******************************************************************************/
void GCON_con_blt( int dx, int dy, int nx, int ny, int sx, int sy )
{
int		i;
	if( dy < sy ){
		for( i = 0; i < ny; i++ ){
			GCON_con_gram2cpu( sx, sy, nx, 1, line_pm );
			GCON_con_cpu2gram( dx, dy, nx, 1, line_pm );
			sy++;
			dy++;
		}
	}else{
		sy += ny - 1;
		dy += ny - 1;
		for( i = 0; i < ny; i++ ){
			GCON_con_gram2cpu( sx, sy, nx, 1, line_pm );
			GCON_con_cpu2gram( dx, dy, nx, 1, line_pm );
			sy--;
			dy--;
		}
	}
	return;
}

int isKanji(int c)
{
    int c1;

    c1 = (c >> 8) & 0xff;
    if (c1 >= 0x81 && c1 <= 0x9f)
        return 1;
    if (c1 >= 0xe0 && c1 <= 0xfd)
        return 1;
    return 0;
}

int isKanji1st(int c1)
{
    if (c1 >= 0x81 && c1 <= 0x9f)
        return 1;
    if (c1 >= 0xe0 && c1 <= 0xfd)
        return 1;
    return 0;
}

/*******************************************************************************
	t[ hׂ
*******************************************************************************/
void GCON_con_fill( int x, int y, int nx, int ny, GCON_PIXEL *col )
{
    int i;

    for( i = 0; i < nx; i++ ){
        line_pm[i] = *col;
    }
    for( i = 0; i < ny; i++ ){
        GCON_con_cpu2gram( x, y, nx, 1, line_pm );
        y++;
    }
    return;
}

/*******************************************************************************
	Ot
*******************************************************************************/
const unsigned char *findGlyph(int c, const struct font_info **pfp)
{
    const struct font_info *fp;
    const struct codetab *ctab;
    int group, nglyph, nb;

    /* R[hSp/ptHĝǂg߂ */
    if (isKanji(c)) {
        fp = &finfo_kanji;
    } else {
        fp = &finfo_ascii;
    }
    ctab = fp->code_tab;
    nglyph = 0;
    /* R[h܂܂O[v */
    for (group = 0; group < fp->numTable; group++) {
        if (ctab[group].first <= c && ctab[group].last >= c) {
            break;
        }
        nglyph += (ctab[group].last - ctab[group].first)+1;
    }
    if (group == fp->numTable) {
        /* Ȃ΁AfBtHgŒu */
        return findGlyph(fp->defchar, pfp);
    }
    c -= ctab[group].first;
    nb = fp->wbytes;
    nb *= fp->gheight;	/* nb = 1̃TCY */
    *pfp = fp;
    /* }`̐擪AhXԂ */
    return (fp->glyph_data + (nglyph + c) * nb);
}

/*******************************************************************************
	Ot\
*******************************************************************************/
void GCON_put_glyph( int c )
{
int		x, y;
const unsigned char	*ft, *rp;
unsigned char	mask;
const struct font_info *fp;
GCON_PIXEL	*gs, *gc;

	/* Ot쐬 */
	ft	= findGlyph(c, &fp);
	gs	= GCON_gram + cur_y * sc_row_height * FRAME_WIDTH + cur_x * sc_col_width;

	for( y = 0; y < fp->gheight; y++ ){
	    rp = ft + y * fp->wbytes;
	    mask = 0x80;
	    gc = gs + y * FRAME_WIDTH;
	    for (x = 0; x < fp->gwidth; x++) {
                WRAP_ADDR(gc);
		if (*rp & mask) {
		    *gc = col_fg;
		} else {
		    *gc = col_bg;
		}
		gc++;
		mask >>= 1;
		if (mask == 0) {
		    mask = 0x80;
		    rp++;
		}
	    }
	}
	return;
}

/*******************************************************************************
	J[\]
*******************************************************************************/
void GCON_invert_cursor( void )
{
int				x, y;
GCON_PIXEL	*glyph, *gp;

	glyph = GCON_gram + cur_y * sc_row_height * FRAME_WIDTH + cur_x * sc_col_width;
	glyph += (sc_row_height-4)*FRAME_WIDTH;
	for( y = 0; y < 4; y++ ){
                gp = glyph;
		for( x = 0; x < sc_col_width; x++ ){
        		WRAP_ADDR(gp);
			*gp++ ^= col_curxor;
		}
		glyph += FRAME_WIDTH;
	}
	return;
}


/*******************************************************************************
	R\[
*******************************************************************************/

void GCON_SelectPlane( PIXEL *base )
{
}

void GCON_Initialize( void )
{
    GCON_PIXEL *gcp;

    GCON_init_blt( (PIXEL *)GRA1_VRAM_BASE, 0 );

    cur_on = 0;
    cur_x  = 0;
    cur_y  = 0;
    col_fg = 0xffff;
    col_bg = 0x0000;
    col_curxor = col_bg ^ 0xffff;

    /* GRAMNA */
    for (gcp = GCON_TOP; gcp < GCON_WRAP; gcp++)
	*gcp = col_bg;
    GCON_cursor_on();
}

void GCON_clear( void )
{
    GCON_PIXEL *gcp;

    GCON_init_blt( (PIXEL *)GRA1_VRAM_BASE, 0 );
    /* GRAMNA */
    for (gcp = GCON_TOP; gcp < GCON_WRAP; gcp++)
	*gcp = col_bg;
}

void GCON_clear_line(int row)
{
    GCON_con_fill( 0, row * sc_row_height,
        sc_cols * sc_col_width, sc_row_height, &col_bg);
}

/*******************************************************************************
	J[\\
*******************************************************************************/
int GCON_cursor_on( void )
{
	if( cur_on ) return(-1);
	cur_on = 1;
	GCON_invert_cursor();
	return(0);
}

/*******************************************************************************
	J[\\
*******************************************************************************/
int GCON_cursor_off( void )
{
	if( cur_on == 0 ) return(-1);
	cur_on = 0;
	GCON_invert_cursor();
	return(0);
}

void GCON_set_color(int fgcolor, int bgcolor)
{
	col_fg = fgcolor;
	col_bg = bgcolor;
}

/*******************************************************************************
	J[\ʒuړ
*******************************************************************************/
int GCON_locate( int x, int y )
{
	if( x >= sc_cols ) return(-1);
	if( y >= sc_rows ) return(-1);

	cur_x = x;
	cur_y = y;
	return(0);
}

/*******************************************************************************
	Ps}
*******************************************************************************/
int GCON_insert_line( int y )
{
	GCON_con_blt( 0, (y + 1) * sc_row_height, sc_cols * sc_col_width, (sc_rows - y - 1) * sc_row_height, 0, y * sc_row_height  );
	GCON_con_fill( 0, y * sc_row_height, sc_cols * sc_col_width, sc_row_height, &col_bg );
	return(0);
}

/*******************************************************************************
	Ps폜
*******************************************************************************/
int GCON_delete_line( int y )
{
	if (y == 0) {
	    GCON_con_fill( 0, 0, GRPH_width, sc_row_height, &col_bg );
	    GCON_gram += (FRAME_WIDTH * sc_row_height);
            WRAP_ADDR(GCON_gram); 
	} else {
	    GCON_con_blt( 0, y * sc_row_height, sc_cols * sc_col_width, (sc_rows - y - 1) * sc_row_height, 0, (y + 1) * sc_row_height  );
	    GCON_con_fill( 0, (sc_rows - 1) * sc_row_height, GRPH_width, sc_row_height, &col_bg );
	}
	return(0);
}

/*******************************************************************************
	P\
*******************************************************************************/
int GCON_putc( int c )
{
    if( c < 0x20 ){
        switch( c ){
            /* 0x09 ^u(TAB) */
            case 0x09:
            {
            int        n;

                /* TABʒu܂ł̕擾 */
                n = tab_cols - (cur_x & (tab_cols - 1));

                /* TABʒuփJ[\ړ */
                cur_x += n;

                /* J[\ʒuʉE[𒴂s */
                if( cur_x >= sc_cols ){
                    GCON_putc( 0x0a );
                }
                break;
            }

            /* 0x0A CEtB[h(LF) */
            case 0x0a:
                cur_x = 0;
                cur_y++;
                if( cur_y >= sc_rows ){
                    cur_y = sc_rows - 1;
                    GCON_delete_line( 0 );
                }
                break;

            /* 0x0D LbWE^[(CR) */
            case 0x0d:
                cur_x = 0;
                break;

            /* 0x0E J[\ʒuɂPs} */
            case 0x0e:
                GCON_insert_line( cur_y );
                break;

            /* 0x19 J[\ʒu̍s폜 */
            case 0x19:
                GCON_delete_line( cur_y );
                break;
            /* 0x08 obNEXy[X(BS) */
            case 0x08:

            /* 0x1D J[\ */
            case 0x1c:
                cur_x--;
                if( cur_x < 0 ){
                    cur_x = sc_cols - 1;

                    cur_y--;
                    if( cur_y < 0 ){
                        cur_x = 0;
                        cur_y = 0;
                    }
                }
                break;

            /* 0x1C J[\E */
            case 0x1d:
                cur_x++;
                if( cur_x >= sc_cols ){
                    cur_x = 0;

                    cur_y++;
                    if( cur_y >= sc_rows ){
                        cur_x = sc_cols - 1;
                        cur_y = sc_rows - 1;
                    }
                }
                break;

            /* 0x1E J[\ */
            case 0x1e:
                cur_y--;
                if( cur_y < 0 ){
                    cur_y = 0;
                }
                break;

            /* 0x1F J[\ */
            case 0x1f:
                cur_y++;
                if( cur_y >= sc_rows ){
                    cur_y = sc_rows - 1;
                }
                break;
        }

    }else{
        if (isKanji(c) && cur_x == sc_cols - 1) {
            GCON_putc( ' ' );
        }
        /* Ot\ */
        GCON_put_glyph( c );

        /* J[\ʒuEֈړ */
        cur_x++;
        if (isKanji(c)) cur_x++;

        /* J[\ʒuʉE[𒴂s */
        if( cur_x >= sc_cols ){
            GCON_putc( 0x0a );
        }

    }
    return(0);
}

/*******************************************************************************
	\(NULLI[)
*******************************************************************************/
int GCON_putstr( char *s )
{
    int c;

    while( *s ){
        c = *s++ & 0xff;
        if (isKanji1st(c)) {
            c = (c << 8) | (*s++ & 0xff);
        }
        GCON_putc(c);
    }
    return(0);
}

/*******************************************************************************
	\(w)
*******************************************************************************/
int GCON_putstrL( char *s, int len )
{
    int i;
    int c;

    for(i = 0; i < len; i++ ){
        c = *s++ & 0xff;
        if (isKanji1st(c)) {
            c = (c << 8) | (*s++ & 0xff);
            i++;
        }
        GCON_putc(c);
    }
    return(0);
}

/* ----------------------------------------------------------------------- */
#define MAX_PRINTFSIZE (255)

/* Ȉprintf֐ */
int t_printf(char *format, ...)
{
	va_list argptr;
	int i;
	char buffer[MAX_PRINTFSIZE + 1];
	va_start(argptr, format);
	i= vsnprintf(buffer, MAX_PRINTFSIZE, format, argptr);
	va_end(argptr);

	GCON_putstrL(buffer, i);	/* OtBbNXR\[\ */

	return i;
}

/* sprintf֐ */
int t_sprintf(char *buffer, char *format, ...)
{
	va_list argptr;
	int i;
	va_start(argptr, format);
	i= vsprintf(buffer, format, argptr);
	va_end(argptr);
	return i;
}

/* putch() */
int t_putch(int c)
{
	GCON_putc(c);		/* OtBbNXR\[\ */
	return c;
}

/* puts() */
int t_puts(char *str)
{
	GCON_putstr(str);	/* OtBbNXR\[\ */
	return 0;
}
