/***********************************************************************/
/*                                                                     */
/*  FILE        :lcd_lib.c                                             */
/*  DESCRIPTION :geometry draw command library                         */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/***********************************************************************/

//`
#include "lcd_lib.h"


/*
  Graphic drawing command
*/
/*
@_`
@@́F`_(x,y)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void dot(short x, short y, unsigned short color , unsigned short opm){
  switch(opm){
  case 0:
    global_lcd_framebuffer[y][x] = color ; break ;
  case 1:
    global_lcd_framebuffer[y][x] &= color ; break ;
  case 2:
    global_lcd_framebuffer[y][x] |= color ; break ;
  case 3:
    global_lcd_framebuffer[y][x] ^= color ; break ;
  default:
    ;
  }
}


/*
@w_̐F擾
@@́F_(x,y)
@@óFFcolor(16rbg(R:G:B=5:5:6))
*/
unsigned short get_dot(short x, short y){
    return global_lcd_framebuffer[y][x];
}


/*
@`
@@́F`Jn_(x1,y1)AI_(x2,y2)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void line(short x1,short y1,short x2,short y2,unsigned short color,short opm){
  int i;
  int dx,dy,sx,sy,E;

  if(x1 == x2){	//
    if( y1 > y2 ) { i=x1; x1=x2; x2=i; i=y1; y1=y2; y2=i; }
    for(i=y1;i<=y2;i++) dot(x1,i,color,opm) ;	//I_`悷悤u=vɒǉ
    return ;}

  if(y1 == y2){	//
    if( x1 > x2 ) { i=x1; x1=x2; x2=i; i=y1; y1=y2; y2=i; }
    for(i=x1;i<=x2;i++) dot(i,y1,color,opm) ;	//I_`悷悤u=vɒǉ
    return ;}

	//ʏ̒
  dx = ( x2 > x1 ) ? x2 - x1 : x1 - x2;
  dy = ( y2 > y1 ) ? y2 - y1 : y1 - y2;

  sx = ( x2 > x1 ) ? 1 : -1;
  sy = ( y2 > y1 ) ? 1 : -1;

  if( dx > dy ){	// X45x
    E = -dx;
	for(i=0 ; i<=dx ; i++){
      dot(x1,y1,color,opm);
      x1 += sx;
      E += 2 * dy;
      if( E >= 0 ){
        y1 += sy;
        E -= 2 * dx;
      }
	}
  }else{			// X45xȏ
    E = -dy;
	for(i=0 ; i<=dy ; i++){
      dot(x1,y1,color,opm);
      y1 += sy;
      E += 2 * dx;
      if( E >= 0 ){
        x1 += sx;
        E -= 2 * dy;
      }
	}
  }  
}


/*
@`
@@́F`Jn_(x1,y1)AI_(x2,y2)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void b_line(short x1,short y1,short x2,short y2,unsigned short color,short opm){
  int i;
  int dx,dy,sx,sy,E;

  if(x1 == x2){	//
    if( y1 > y2 ) { i=x1; x1=x2; x2=i; i=y1; y1=y2; y2=i; }
    for(i=y1;i<y2;i++) fcrcl(x1-1,i-1,x1+1,i+1,color,opm) ;
    return ;}

  if(y1 == y2){	//
    if( x1 > x2 ) { i=x1; x1=x2; x2=i; i=y1; y1=y2; y2=i; }
    for(i=x1;i<x2;i++) fcrcl(i-1,y1-1,i+1,y1+1,color,opm) ;
    return ;}

	//ʏ̒
  dx = ( x2 > x1 ) ? x2 - x1 : x1 - x2;
  dy = ( y2 > y1 ) ? y2 - y1 : y1 - y2;
  sx = ( x2 > x1 ) ? 1 : -1;
  sy = ( y2 > y1 ) ? 1 : -1;

  if( dx > dy ){		// X45x
    E = -dx;
	for(i=0 ; i<=dx ; i++){
      fcrcl(x1-1,y1-1,x1+1,y1+1,color,opm);
      x1 += sx;
      E += 2 * dy;
      if( E >= 0 ){
        y1 += sy;
        E -= 2 * dx;
      }
	}
  }else{				// X45xȏ
    E = -dy;
	for(i=0 ; i<=dy ; i++){
      fcrcl(x1-1,y1-1,x1+1,y1+1,color,opm);
      y1 += sy;
      E += 2 * dx;
      if( E >= 0 ){
        x1 += sx;
        E -= 2 * dy;
      }
	}
  }  
}



/*
@Op``
@@́F_(x1,y1)(x2,y2)(x3,y3)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void tri(short x1,short y1,short x2,short y2,short x3,short y3,unsigned short color,short opm){
  line(x1,y1,x2,y2,color,opm);
  line(x2,y2,x3,y3,color,opm);
  line(x1,y1,x3,y3,color,opm);
}


/*
@hׂOp``
@@́F_(x1,y1)(x2,y2)(x3,y3)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void ftri(short x1,short y1,short x2,short y2,short x3,short y3,unsigned short color,short opm){
  int i, stk_flag_u, stk_flag_l;
  int cpx, cpy;
  int stack[4][2];
  static unsigned short data;
  
  for(i=0;i<4;i++){
    stack[i][0] = 0;
    stack[i][1] = 0;
  }
  line(x1,y1,x2,y2,color,opm);
  line(x2,y2,x3,y3,color,opm);
  line(x1,y1,x3,y3,color,opm);
  cpx = (x1 + x2 + x3)/3; cpy = (y1 + y2 + y3)/3;
  i=0;
  do{
    stk_flag_u = 0; stk_flag_l = 0;
    while((data = get_dot(cpx,cpy)) != color){
      cpx--;
	}
    cpx++;
    do{
      dot(cpx,cpy,color,opm);

      if((get_dot(cpx,cpy+1) != color) & stk_flag_u == 0){
        stk_flag_u = 1;
        stack[i][0] = cpx; stack[i][1] = cpy + 1;
        i++;
      }      
      if((get_dot(cpx,cpy-1) != color) & stk_flag_l == 0){
        stk_flag_l = 1;
        stack[i][0] = cpx; stack[i][1] = cpy - 1;
        i++;
      }
      cpx++;
	}while(get_dot(cpx,cpy) != color);
    if(i>0){
      i--;
      cpx = stack[i][0]; cpy = stack[i][1];
      data = get_dot(cpx,cpy);
	} else break;
  }while(i>0);

}


/*
@~`(w肵Q_Ɉ͂܂ꂽlp`ɐڂ~Aȉ~)
@@́F_(x1,y1)(x2,y2)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void crcl(short xs,short ys,short xe,short ye,unsigned short color,short opm){
  long x, y, a, b, xc, yc;
  long d;
  long F, H, r;

  xc = xs ; yc = ys ;		//S_xW߂
  xc = (xe - xc)/2 + xs ;
  a = (xe > xc) ? xe - xc : xc - xe ;	//a߂
  yc = (ye - yc)/2 + ys ;	//S_yW߂
  b = (ye > yc) ? ye - yc : yc - ye ;	//b߂
  r = a * b;
  x = a;					//`Jn_
  y = 0;
  d = b * r;
  F = -2 * d + b * b + 2 * a * a;
  H = -4 * d + 2 * b * b + a * a;
  
  //㉺EΏ̂̂ߑȉ~1/4ZAS_`
  while( x >= 0){
    dot(xc + x,yc + y,color,opm);	//S_`
    dot(xc - x,yc + y,color,opm);
    dot(xc + x,yc - y,color,opm);
    dot(xc - x,yc - y,color,opm);
    if( F >= 0 ){
      x--;
      F -= 4 * b * b * x;
      H -= 4 * b * b * x - 2 * b * b;
    }
    if( H < 0 ){
      y++;
      F += 4 * a * a * y + 2 * a * a;
      H += 4 * a * a * y;
	}		
  }  
}



/*
@hׂ~`(w肵Q_Ɉ͂܂ꂽlp`ɐڂ~Aȉ~)
@@́F_(x1,y1)(x2,y2)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void fcrcl(short xs,short ys,short xe,short ye,unsigned short color,short opm){
  long x, y, a, b, xc, yc;
  long d;
  long F, H, r;

  xc = xs ; yc = ys ;		//S_xW߂
  xc = (xe - xc)/2 + xs ;
  a = (xe > xc) ? xe - xc : xc - xe ;	//a߂
  yc = (ye - yc)/2 + ys ;	//S_yW߂
  b = (ye > yc) ? ye - yc : yc - ye ;	//b߂
  r = a * b;	
  x = a;					//`Jn_
  y = 0;
  d = b * r;
  F = -2 * d + b * b + 2 * a * a;
  H = -4 * d + 2 * b * b + a * a;

  //㉺EΏ̂̂ߑȉ~1/4ZAŌ
  while( x >= 0){
    line(xc - x,yc + y,xc + x,yc + y,color,opm);	//ĥׂߐ`
    line(xc - x,yc - y,xc + x,yc - y,color,opm);
    if( F >= 0 ){
      x--;
      F -= 4 * b * b * x;
      H -= 4 * b * b * x - 2 * b * b;
    }
    if( H < 0 ){
      y++;
      F += 4 * a * a * y + 2 * a * a;
      H += 4 * a * a * y;
	}		
  }
}


/*
@hׂlp``
@@́F_(x1,y1)(x2,y2)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void rct(short x1,short y1,short x2,short y2,unsigned short color,short opm){
   int i;

   if ( x1 > x2 ) { i=x1; x1=x2; x2=i; }
   if ( y1 > y2 ) { i=y1; y1=y2; y2=i; }

   line(x1,y1,x2,y1,color,opm);
   line(x1,y2,x2,y2,color,opm);
   line(x1,y1,x1,y2,color,opm);
   line(x2,y1,x2,y2,color,opm);
}


/*
@hׂlp``
@@́F_(x1,y1)(x2,y2)AFcolor(16rbg(R:G:B=5:5:6))A`惂[hopm(0:u,1:AND,2:OR,3:EOR)
@@óFȂ
*/
void frct(short x1,short y1,short x2,short y2,unsigned short color,short opm){
   int i;

   if ( x1 > x2 ) { i=x1; x1=x2; x2=i; }
   if ( y1 > y2 ) { i=y1; y1=y2; y2=i; }

   for(i=y1;i<=y2;i++)
     line(x1,i,x2,i,color,opm) ;
}

