/***********************************************************************/
/*                                                                     */
/*  FILE        :touch.h                                               */
/*  DESCRIPTION :touch panel                                           */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/***********************************************************************/
/*
PC3	PU
PC2 YHL
PC1 YEN
PC0 XEN
*/
#define T_idle_DDR	0x07	//X:disable(H),Y:disble(H),PU:high-Z
#define T_idle_DR	0x03	
#define T_sense_DDR	0x0f	//X:disable(H),Y:enable(L),YHL:L,PU:H
#define T_sense_DR	0x09
#define T_posX_DDR	0x07	//X:enable(L),Y:disable(H),YHL:X(L),PU:Hgh-Z
#define T_posX_DR	0x02
#define T_posY_DDR	0x07	//X:disnable(H),Y:enable(L),YHL:H,PU:Hgh-Z
#define T_posY_DR	0x05
#define ON  0
#define OFF 1

#define X_UL	400
#define Y_UL	3430

#define X_DL	390
#define Y_DL	570

#define X_UR	3650
#define Y_UR	3430

#define X_DR	3660
#define Y_DR	580

typedef struct {
  short x_min, x_max;
  short y_min, y_max;
} TP_CALIBRATION;

struct s_timer {
    void (*tfunc)();
    int counter;
    struct s_timer *next;
};

extern TP_CALIBRATION tp_calib_data;
extern int df_check(TP_CALIBRATION *tpc);
extern void df_write(TP_CALIBRATION *tpc);
extern void add_timer(struct s_timer *ptimer);
extern void delay_ms (int ms);
